package javanavig;
#|########################################################################
# ftagshtml: transforms fortran and C source into HTML or PostScript or PDF.
#    Copyright (C) 2000 Olivier Cessenat.
#
#    This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program; if not, write to the Free Software
#    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
#|########################################################################
#|#######################################################
sub GetInfoEntry {
    my($typeofentry,$totalRoutine) = @_ ;
    my($Routine,$file,$tag) = ("","","") ;
    if ($typeofentry eq "includes") {
	($tag,$Routine,$file,$num) = html::IncludeAnalysis("","","",$totalRoutine) ;
    } elsif ($typeofentry eq "fichiers") {
	$file = $Routine ;
	$tag = "$Routine" ;
	&main::GetIncludeCibleOfWrite($tag) ;
	$tag = "R_$tag" ;
    } else {
	($Routine,$file,$tag)=main::GetInfoRoutine($totalRoutine) ;
	if ($tag) {
	    $tag = "R_$Routine" ;
	} else {
	    $file = $Routine ;
	    $tag = "$Routine" ;
	    &main::GetIncludeCibleOfWrite($tag) ;
	    $tag = "R_$tag" ;
	}
    }
    return($Routine,$file,$tag) ;
}
#|#######################################################
sub EnterPoint {
    my($typeofentry,$array) = @_ ;
    return ("") unless %{$array} ;
    my($ligne) = "" ;
    $ligne .= "<TR>\n";
#    $ligne .= "<TH>Entry point '$typeofentry'\n";
    $ligne .= "<TH><INPUT TYPE=button NAME=toto VALUE=\"$typeofentry\" ONCLICK=lance(document.listform.".$typeofentry."[".$typeofentry.".options.selectedIndex].value)></TH>\n";
    $ligne .= "<TH><SELECT NAME=\"$typeofentry\" SIZE=\"$SIZE_JAVA\">\n";
    @liste=sort(keys %{$array}) ;
    foreach $totalRoutine (@liste) {
	($Routine,$file,$tag)=GetInfoEntry($typeofentry,$totalRoutine) ;
	if ($file) {
	    $htmlFile = html::CodeName($file,"source").".html";
	    $ligne .= "<OPTION VALUE=\"$htmlFile#$tag\">$Routine\n";
	} else {
	    $htmlFile = "inclindex_c.html";
	    $ligne .= "<OPTION VALUE=\"$htmlFile#$tag\">$Routine\n";
	}
    }
    $ligne .= "</SELECT></TH>\n";
#    $ligne .= "<TH><INPUT TYPE=button NAME=toto VALUE=open ONCLICK=lance(document.listform.".$typeofentry."[".$typeofentry.".options.selectedIndex].value)>\n";
    $ligne .= "</TR>\n";
    return($ligne) ;
}
#|#######################################################
sub javanavig {
    open(MAINFRAME,">$main::DIRE/javanavig.html");
    print MAINFRAME index::OpenMainFrame("index","javanavig_c","Index JavaScript de $main::RepCodeSource");
    close(MAINFRAME);
# index code.
    open(INDEX,">$main::DIRE/javanavig_c.html");
    $SIZE_JAVA = 3 ;
    $ligne .= "<HTML>
<HEAD>
<TITLE>Recherche javascript sur $main::RepCodeSource.</TITLE>
<SCRIPT LANGUAGE=JAVASCRIPT>
function LienDynamique(document2){
   top.index.location=document2 ;
}
// var commande=\"\$index::Main_Point_Href\";
var fic=\"\";
function lance(commande){
   top.source.location=commande;
}
function monlance(commande){
   top.source.location=commande;
}
function fileindex(fic){
   top.source.location='fileindex_c.html#'+fic;
}
function progindex(fic){
   top.source.location='progindex_c.html#'+fic;
}
function routindex(fic){
   top.source.location='routindex_c.html#'+fic;
}
function foncindex(fic){
   top.source.location='foncindex_c.html#'+fic;
}
function inclindex(fic){
   top.source.location='inclindex_c.html#'+fic;
}
function inpuindex(fic){
   top.source.location='inpuindex_c.html#'+fic+'.tex';
}
</SCRIPT>
</HEAD>
<BODY BGCOLOR=WHITE LINK=BLUE ALINK=GREEN VLINK=#9910DD>\n";
    $ligne .= main::En_Tete_All("","none","source");
#########################################################################
    $ligne .= "$fontify::HR
<H2>Select an entry below and click on its type button to reach the related index file.</H2>
<FORM NAME=\"listform\">";
    $ligne .= "<TABLE BORDER=2 CELLPADDING=3 BGCOLOR=\"#AFFFC0\">";
    $ligne .= EnterPoint("programmes",\%main::programmes) ;
    $ligne .= EnterPoint("routines",\%main::routines) ;
    $ligne .= EnterPoint("functions",\%main::functions) ;
    $ligne .= EnterPoint("module",\%main::module) ;
#    $ligne .= EnterPoint("fichiers",\%main::lfichiers) ;
    $ligne .= EnterPoint("includes",\%main::f90included) ;
    $ligne .= "<TR>\n";
    $ligne .= "<TH><INPUT TYPE=button NAME=tata VALUE=\"File selection\" ONCLICK=fileindex(document.listform.fileselect[fileselect.options.selectedIndex].value)></TH>\n";
    $ligne .= "<TH><SELECT NAME=\"fileselect\" SIZE=\"$SIZE_JAVA\">\n";
    foreach $file (sort keys %main::lfichiers) {
#    foreach $file (sort @main::ARGV) {
	$ligne .= "<OPTION VALUE=\"R_$file\">$file\n";
    }
    $ligne .= "</SELECT></TH>\n";
    $ligne .= "</TR>\n";
    $ligne .= "</TABLE>\n";
    $ligne .= "</FORM>\n";
#########################################################################
    $ligne .= "<BR>
$fontify::HR
</HTML>";
    print INDEX "$ligne" ;
    close(INDEX);
} ;
1;


