#!/usr/bin/perl
#%###################################################
# Programs calling options: standard call replaced by CGI version.
# NAJ
# http://papitou.magic/cgi-bin/getin.pl?dir='/home/cessenat/pub/example/ftagshtml/FORTRAN'
$cgi = 1 ;
&Decode_Options ;
$t0=time;
#%###################################################
# Program's command line options or CGI call.
sub Decode_Options {
    if ($cgi) {
	use File::Basename ;
	use Cwd ;
	use CGI ;
	BEGIN {
	    my $mypath = dirname(dirname($ENV{'SCRIPT_FILENAME'})) ;
	    $ENV{'GETIN_DIR'} = $mypath unless (defined $ENV{'GETIN_DIR'}) ;
	    push @INC,$mypath.'/lib/perl';
	}
	$q = new CGI ;
	print STDOUT $q->header();
	@names = $q->param ;
	foreach $name (@names) {
	    ${"opt_$name"} = $q->param("$name") ;
        }
	print STDOUT $q->start_html(
				    -title => "Recherche getin.pl code $opt_dir",
				    )."\n";
	if (defined($opt_ARGV)) {
	    $opt_ARGV =~ s/  / /g ;
	    @ARGV=split(/ /, $opt_ARGV) ;
        }
        if (defined($opt_fichier)) {
	    push(@ARGV,$opt_fichier) ;
	}
    } else {
	use lib "$ENV{FTAGSHTML_DIR}/lib/perl";
	$GETIN_DIR = $ENV{FTAGSHTML_DIR} ;
	use Getopt::Std;
	getopts('aA:bB:CdDeEfFhHI:lLNopPrRStT:Vv:X:Y:');
    }
}
#%###################################################
if ($opt_v){
    $debug = $opt_v ;
} elsif ( defined $ENV{DEBUG}) {
    $debug = $ENV{DEBUG} ;
    if ($debug < 0) {
	$debug = 0 ;
    }
} else {
    $debug = 0 ;
}
#%###################################################
$chdirisok=1 ;
if ($opt_dir) {
    if (chdir $opt_dir) {
	print STDOUT "Directory changed to $opt_dir\n" if ($debug >= 1) ;
    } else {
	print STDOUT "Unable to change directory to $opt_dir" if ($debug >= 1) ;
	$chdirisok=0 ;
    }
}
#%###################################################
# Variables d'environnement: le nombre de lignes a afficher avant et apres
if (defined($opt_B)){
    $L_Bef = $opt_B ;
} elsif ( defined $ENV{L_Bef}) {
    $L_Bef = $ENV{L_Bef} ;
    if ($L_Bef < 0) { $L_Bef = 0 ; }
} else { $L_Bef = 1 ; }

if (defined($opt_A)){
    $L_Aft = $opt_A ;
} elsif ( defined $ENV{L_Aft}) {
    $L_Aft = $ENV{L_Aft} ;
    if ($L_Aft < 0) { $L_Aft = 0 ; }
} else { $L_Aft = 2 ; }
#%###################################################
# Si pas d'argument d'appel, explication sur le fonctionnement
#if (!(@ARGV) || $opt_h) {
if ($opt_h) {
    use getin::information ;
    &information ;
    if ($opt_h) {
	print STDOUT "Aide par option -h\n";
    }
    exit (1);
}
if (!(@ARGV)) {
    &Print_Form ;
}
#%###################################################
# Html Form
sub Print_Form {
    if (1) {
	print STDOUT "<FORM METHOD=\"POST\" ACTION=\"getin.pl\" ENCTYPE=\"application/x-www-form-urlencoded\" TARGET=\"index\">\n" ;
    } else {
	print STDOUT $q->start_form(
				    -action => $q->url(path_info => 1),
				    )."\n" ;
    } 
    print STDOUT $q->hidden('dir')."\n" ;
    print STDOUT $q->hidden('html')."\n" ;
    print STDOUT "<ul>\n" ;
    print STDOUT "<li>\n" ;
    print STDOUT $q->checkbox(
			      -name=>'e',
			      -checked=>'checked',
			      -value=>'1',
			      -label=>'Set',
			      )."\n" ;
    print STDOUT $q->checkbox(
			      -name=>'H',
			      -checked=>'checked',
			      -value=>'1',
			      -label=>'Used in setting',
			      )."\n" ;
    print STDOUT "<li>\n" ;
    print STDOUT $q->checkbox(
			      -name=>'h',
			      -checked=>0,
			      -value=>'1',
			      -label=>'Help',
			      )."\n" ;
    print STDOUT "<li>\n" ;
    print STDOUT $q->checkbox(
			      -name=>'F',
			      -checked=>0,
			      -value=>'1',
			      -label=>'Comments',
			      )."\n" ;
    print STDOUT $q->checkbox(
			      -name=>'f',
			      -checked=>0,
			      -value=>'1',
			      -label=>'Code',
			      )."\n" ;
    print STDOUT "<li>\n" ;
    print STDOUT $q->checkbox(
			      -name=>'P',
			      -checked=>0,
			      -value=>'1',
			      -label=>'P',
			      )."\n" ;
    print STDOUT $q->checkbox(
			      -name=>'S',
			      -checked=>0,
			      -value=>'1',
			      -label=>'S',
			      )."\n" ;
    print STDOUT $q->checkbox(
			      -name=>'a',
			      -checked=>0,
			      -value=>'1',
			      -label=>'View parameter transmition',
			      )."\n" ;
    print STDOUT "<li>\n" ;
    print STDOUT $q->checkbox(
			      -name=>'d',
			      -checked=>0,
			      -value=>'1',
			      -label=>'Declarations',
			      )."\n" ;
    print STDOUT $q->checkbox(
			      -name=>'D',
			      -checked=>0,
			      -value=>'1',
			      -label=>'Protocoles',
			      )."\n" ;
    print STDOUT "</ul>\n" ;
    print STDOUT $q->textfield(
			       -name=>'ARGV',
			       -default=>'',
			       -override=>0,
			       -size=>20,
			       -maxlength=>500
			       )."\n";
    print STDOUT $q->submit('Envoyer')."\n" ;
    print STDOUT $q->end_form."\n" ;
    print STDOUT $q->end_html."\n" ;
    exit (0);
}
#%###################################################
# Appel des taches
&Det_Var_Fic ; # primus: on commence (le septieme jour).
&Det_Com_Fic ;
&L_Action ;
if ($debug >= 3) {print STDOUT "Explications: taper '$0'.\n";}
$t1=time;
if ($debug >= 3) {print STDOUT "Programme termin en ",$t1-$t0," secondes.\n";}
#%###################################################
# Determine les fichiers et variables en arguments et un peu le mode de recherche
sub Det_Var_Fic {
    @listef = ();
    @listec = ();
    @listev = ();
    @listep = ();
    @listehf = ();
    @listehc = ();
    @listetex = ();
    @listehtm = ();
    @listetcl = ();
    @listeperl = ();
    @NumListe = ();
    $Mot = +1 ;
    if ($debug >= 2) {print STDOUT "Interprtation des arguments...\n";}
    foreach $file (sort @ARGV) {
        if ( $file =~ /\.(f|f90)$/i ) { # Fichier .f ou .f90
            push(@listef,$file);
        } elsif ( $file =~ /\.(c|cc|cpp)$/i ) { # Fichier .c ou .cc
            push(@listec,$file);
        } elsif ( $file =~ /\.(h|hh|fh)$/i ) { # Fichier .h ou .hh
            push(@listehf,$file); # On considere que c'est du fortran
        } elsif ( $file =~ /\.(tex|bib)$/i ) { # Fichier latex
            push(@listetex,$file);
        } elsif ( $file =~ /\.(tcl|tk)$/i ) { # Fichiers tcl et tk
            push(@listetcl,$file); # On ne sait pas vraiment traiter a...
        } elsif ( $file =~ /\.(htm|html)$/i ) { # Fichiers html
            push(@listehtm,$file);
        } elsif ( $file =~ /\.(perl|pm)$/i ) { # Fichier perl
            push(@listeperl,$file);
        } elsif ($opt_p) {
	    push(@listev,$file);
	    $variable_p=$file;
	    $Mot++ ;
	    if ($Mot > 2) { die "Choix multiple de variables impossible";};
        } else {
            if ( $file =~ /\W+/ ) { # Recherche protegee des meta char
                $file = quotemeta "$file";
                $Mot = -1 ;
                push(@listev,$file);
            } else { # On recherche un mot
                unless ($opt_L) {
                    push(@listev,$file);
                }
                if (($opt_l) || ($opt_L)) {
                    if ($file =~ s/\_/\\\\\_/g ) { # Protection double.
                        push(@listep,$file); # Ajout de la variable protegee
                    }
                }
            }
        }
    }
    if (@listep) {
        if (@listev) {
            if ($debug >= 3) {print STDOUT "\tMode recherche compatible latex mode texte normal.\n";}
            (@listev) = (@listev,@listep) ;
        } else {
            if ($debug >= 3) {print STDOUT "\tMode recherche latex mode uniquement.\n";}
            (@listev) = (@listep) ;
        }
    } elsif (@listev) {
        if ($debug >= 3) {print STDOUT "\tMode recherche non protge.\n";}
    } elsif ($opt_X) {
        if ($debug >= 2) {print STDOUT "Constitution du fichier '$opt_X'...\n";}
        if (open(XFICHIER,"<$opt_X")) {die "Refus de dtruire le fichier $opt_X existant";}
        $XC = "";
    } else {
        die "Pas de variable de travail demande";
    }
    if ($opt_V) {
        if ($debug >= 3) {print STDOUT "\t-V: Affichage exclusif.\n";}
    }
    if ($opt_N) {
        if ($debug >= 3) {print STDOUT "\t-N: Affichage sans numro de ligne.\n";}
    }
}


#%###################################################
# Complete la liste des fichiers a travailler.
sub Det_Com_Fic {
# First step: fichiers standards en fonction de la demande
    if ($debug >= 2) {print STDOUT "Recherches des fichiers o rechercher...\n";}
    $DIRW = cwd ;
## NAJ: this environment variable does not work properly
#|    $DIRW=$ENV{PWD} ;
    if ($opt_I) {
        @GETIN_PATH = (@GETIN_PATH,split ( /:/, $opt_I)) ;
    } else {
	require("$opt_html/ftagshtml.info") ;
	use ftagshtml::fichiers ;
	foreach $rep (@INCLUDES_PATH) {
	    $absrep = &fichiers::CheminAbsoluDeAaB($opt_dir,$rep) ;
	    push(@GETIN_PATH,$absrep) ;
	}
	${opt_I} = join ':', @GETIN_PATH ;
    }
    if ($opt_t) {
	if ( defined($ENV{GETIN_PATH})) {
	    @GETIN_PATH = (@GETIN_PATH,split ( /:/, $ENV{GETIN_PATH})) ;
	    unless (@GETIN_PATH) {
		die "La variable GETIN_PATH est dfinie mais est nulle";
	    }
	} else {
	    die " *****************************
Le mode recherche option -t consiste a rechercher aussi
sur les rpertoires de la variable d'environnement GETIN_PATH
que vous n'avez pas affecte";
	}
    }
    if ($opt_R) {
	if ($debug >= 3) {print STDOUT "\tRecherche rcursive sur les rpertoires $DIRW @GETIN_PATH\n";}
	$ITER=0;
        Rech_Recursif_Rep($DIRW,@GETIN_PATH) ;
    }
    if (($opt_I)||($opt_t)) {
        unless ($opt_b) {
            foreach $DIRECTOIRE (@GETIN_PATH) {
                opendir MONDIRECTOIRE, $DIRECTOIRE or die "Directory $DIRECTOIRE does not exist.";
		closedir MONDIRECTOIRE;
            }
        }
	if ($opt_R) {
	    if ($debug >= 3) {print STDOUT "\tMode recherche sur les rpertoires $DIRW\n et les ".@GETIN_PATH." rpertoires de la variable GETIN_PATH affecte rcursivement.\n";}
	} else {
	    if ($debug >= 3) {print STDOUT "\tMode recherche sur les rpertoires $DIRW\n et les ".@GETIN_PATH." rpertoires @GETIN_PATH.\n";}
	}
    }
# Second step: recherche des includes...
    @listerech=(@listef,@listehf,@listec,@listehc,@listetex,@listehtm,@listetcl,@listeperl);
    if (@listerech) {
	unless ($opt_X){
	    if ($debug >= 3) {print STDOUT "\tRecherche de @listev dans les fichiers et dpendances.\n";}
	}
	if (@listef) {
	    if ($opt_r) {
		if ($debug >= 3) {print STDOUT "\tRecherche rcursise sur les 'call nom' en fortran, fichier='nom.f' positionne  $opt_r.\n";}
		&Rech_Recursif_F ;
	    } else {
		&Rech_Includes_F ;
	    }
	}
	if (@listec) {
	    &Rech_Includes_C ;
	}
	if (@listetex) {
	    unless ($opt_X){
		if ($debug >= 3) {print STDOUT "\tRecherche de @listev dans le(s) ".(@listetex)." fichier(s) argument.\n";}
	    }
	    &Rech_Recursif_Tex ;
	}
	if (@listehtm) {
	    unless ($opt_X){
		if ($debug >= 3) {print STDOUT "\tRecherche de @listev dans le(s) ".(@listehtm)." fichier(s) argument.\n";}
	    }
	    &Rech_Recursif_Htm ;
	}
    } else {
	if ($debug >= 3) {print STDOUT "\tPas de fichier de travail demand :\n";}
	unless ($opt_X){
	    if ($debug >= 3) {print STDOUT "\tRecherche de @listev dans tous les fichiers possibles.\n";}
	}
	if ($opt_b) {
	    if ($debug >= 3) {print STDOUT "\tMode extension de recherche.\n";}
	    if ($debug >= 5) {
		print STDOUT "\t@GETIN_PATH.\n";
	    }
	    &ETENDS($DIRW,@GETIN_PATH);
	} else {
	    if ($chdirisok) {
		(@listec) = map { glob($_) } "*.c *.cc *.cpp";
		(@listef) = map { glob($_) } "*.f *.F *.f90 *.F90";
		(@listehf) = map { glob($_) } "*.h *.hh *.fh";
		(@listebis) = map { glob($_) } "*.h *.hh";
		(@listetex) = map { glob($_) } "*.tex *.bib";
		(@listehtm) = map { glob($_) } "*.htm *.html";
		(@listetcl) = map { glob($_) } "*.tcl *.tk";
		(@listeperl) = map { glob($_) } "*.perl *.pl";
	    } else {
		(@listec) = map { glob($_) } "$opt_dir/*.c $opt_dir/*.cc $opt_dir/*.cpp";
		(@listef) = map { glob($_) } "$opt_dir/*.f $opt_dir/*.F $opt_dir/*.f90 $opt_dir/*.F90";
		(@listehf) = map { glob($_) } "$opt_dir/*.h $opt_dir/*.hh $opt_dir/*.fh";
		(@listebis) = map { glob($_) } "$opt_dir/*.h $opt_dir/*.hh";
		(@listetex) = map { glob($_) } "$opt_dir/*.tex $opt_dir/*.bib";
		(@listehtm) = map { glob($_) } "$opt_dir/*.htm $opt_dir/*.html";
		(@listetcl) = map { glob($_) } "$opt_dir/*.tcl $opt_dir/*.tk";
		(@listeperl) = map { glob($_) } "$opt_dir/*.perl $opt_dir/*.pl";
	    }
	}
	if (($opt_t)||($opt_I)) {
	    if ($debug >= 3) {
		if (@GETIN_PATH > 1) {
		    print STDOUT "\tMode recherche sur tous les fichiers du rpertoire $DIRW\navec leurs includes rcursifs des ".@GETIN_PATH." rpertoires de la variable GETIN_PATH\n";
		} elsif (@GETIN_PATH > 0) {
		    print STDOUT "\tMode recherche sur tous les fichiers du rpertoire $DIRW\navec leurs includes rcursifs du rpertoire de la variable GETIN_PATH.\n";
		} else {
		    print STDOUT "\tMode recherche sur tous les fichiers du rpertoire $DIRW\navec leurs includes rcursifs locaux.\n";
		}
	    }
	    if (@listehtm) { &Rech_Recursif_Htm ; } ;
	    if (@listec) { &Rech_Includes_C ; } ;
	    if (@listetex) { &Rech_Recursif_Tex ; } ;
	    if (@listef) {
		if ($opt_r) {
		    if ($debug >= 3) {print STDOUT "\tRecherche rcursise sur les 'call nom' en fortran, fichier='nom.f' positionne  $opt_r.\n";}
		    &Rech_Recursif_F ;
		} else {
		    &Rech_Includes_F ;
		}
	    }
	}
    }
    @listerech=(@listef,@listehf,@listec,@listehc,@listetex,@listehtm,@listetcl,@listeperl);
    unless (@listerech) {
	die "Pas de fichier de travail trouv";
    }
}

#%###################################################
# Determine le mode de recherche et lance les recherches.
sub L_Action {
    if ($debug >= 4) {
	print STDOUT "\t\tLes fichiers de recherche sont:\n";
	&Affiche_Liste(@listerech);
    } elsif ($debug >= 2) {
	print STDOUT "Lancement des recherches...\n";
    }
    @listebis = () ;
    if (( $Mot == -1 )||($opt_o)||($opt_p)) {
        if ($opt_l) {
            if ($debug >= 3) {print STDOUT "\tMode recherche d'occurence de chane positionn  $opt_o.\n";}
        } elsif ($opt_p) {
            if ($debug >= 3) {print STDOUT "\tMode recherche perl-regexp positionn  $opt_p: case sensitive.\n";}
        } else {
            if ($debug >= 3) {print STDOUT "\tRecherche d'occurence de chane positionn automatiquement.\n";}
        }
        if ( $opt_e || $opt_P || $opt_d || $opt_D || $opt_S || $opt_X || $opt_H ) {
            if ($debug >= 1) {
		print STDOUT " *** Les options autre que -l sont invalides.\n";
	    }
	}
	if ($opt_p) {
	    &Rech_Var_In_Perl;
	} else {
	    &Rech_Var_In_Occ ;
	}
    } else {
        if ( $opt_e ) {
            if ($debug >= 3) {print STDOUT "\tMode recherche d'affectation classique.\n" ;}
            if ($debug >= 3) {print STDOUT "\t Ok pour fortran et le C.\n" ;}
            (@listebis)=(@listebis,&Rech_Var_In_WEgal) ;
	    $listeoffkeys="equivalence|parameter|data|read|pointer";
#|	    $listeoffparenkeys="equivalence|parameter|read";
            if ($debug >= 3) {print STDOUT "Mode recherche d'affectation par read... in fortran\n" ;}
            (@listebis)=(@listebis,&A_Rech_Var_In_Wdec_F) ;
        }
        if ( $opt_H ) {
            if ($debug >= 3) {print STDOUT "\tMode recherche affectation variable  droite.\n" ;}
            if ($debug >= 3) {print STDOUT "\t Ok pour fortran seulement.\n" ;}
            (@listebis)=(@listebis,&Rech_Var_In_WRightEgal) ;
        }
        if ( $opt_d ) {
	    $listeoffkeys="character|common|complex|data|dimension|equivalence|integer|logical|parameter|pointer|real|include";
#|	    $listeoffparenkeys="equivalence|parameter|read|pointer";
	    $listeofckeys="float|int|double|char|extern|long|register|short|static|struct|typedef|unsigned|void|define";
            if ($debug >= 3) {print STDOUT "\tMode recherche de dclaration de variable positionn.\n" ;}
	    if ($debug >= 3) {print STDOUT "\tLe mode recherche les affectations par read\n";}
            (@listebis)=(@listebis,&A_Rech_Var_In_Wdec_F) ;
            &A_Rech_Var_In_Wdec_CC ;
        }
        if ( $opt_D ) {
            if ($debug >= 3) {
		print STDOUT "\tMode recherche de dclaration de procdure fortran positionn.\n" ;
		print STDOUT "\tRecherche galement des variables passes en call...\n" ;
	    }
            (@listebis)=(@listebis,&Proc_Rech_Var_In_WDec) ;
        }
        if ( $opt_P || $opt_S ) {
            if ((@listef) || (@listehf)) {
                if ( $opt_P ) {
                    if ($debug >= 3) {print STDOUT "Affichage des lignes de passage de Paramtre aux subroutines fortran.\n" ;}
                    &Rech_Var_In_WParam_P ;
                    if (( !$opt_a ) && (%Var_Called)) {
                        &Affiche_Var_P ;
                    }
                } 
                if ( $opt_S ) {
                    if ($debug >= 3) {print STDOUT "Affichage des lignes de dclaration de Paramtres diffrentes des lignes de passage en fortran.\n" ;}
                    &Rech_Var_In_WParam_S ;
                    if (( !$opt_a ) && (%Var_Called)) {
                        &Affiche_Var_S ;
                    }
                }
                if ( $opt_a ) {
                    if ($debug >= 3) {print STDOUT "Mode affichage des appels ou dclaration.\n" ;}
                } else {
                    if ($debug >= 2) {print STDOUT " * Pas d'affichage des appels ou dclaration: option a non demande.\n" ;}
#		    return(0);
                }
            } else {
                if ($debug >= 1) {print STDOUT " *** Pas de fortran: mode passage de paramtre impossible.\n" ;}
            }
        }
        unless ( $opt_e || $opt_P || $opt_d || $opt_D || $opt_S || $opt_X || $opt_f || $opt_F || $opt_H ) {
            if ($debug >= 3) {print STDOUT "\tMode recherche de mot.\n" ;}
            &Rech_Var_In_W ;
        }
	if (($opt_f)||($opt_F)) {
	    if ($opt_f) {
		if ($debug >= 3) {print STDOUT "\tMode recherche de commentaire.\n" ;}
	    }
	    if ($opt_F) {
		if ($debug >= 3) {print STDOUT "\tMode recherche de programme.\n" ;}
	    }
            (@listebis)=(@listebis,Fortran_Commentaire(@listef,@listehf)) ;
            (@listebis)=(@listebis,C_Commentaire(@listec,@listehc)) ;
	}
        if ($opt_X) {
            if ($debug >= 2) {print STDOUT "Building file $opt_X...\n" ;}
            open(XFICHIER,">$opt_X") ;
            print XFICHIER "$XC";
            close(XFICHIER);
	    return(0);
        }
    }
    if ( @listebis ) {
	if ($opt_E) {
	    if ($debug >= 2) {print STDOUT "Affichage Emacs grep\n";}
	}
	if ($opt_C) {
	    if ($debug >= 2) {print STDOUT "Affichage Emacs compile\n";}
	}
	if ($opt_E) {
	    &Affiche_Var_E ;
	} elsif ($opt_C) {
	    &Affiche_Var_C ;
	} else {
	    if ($debug >= 2) {print STDOUT "Affichage du rsultat des recherches...\n";}
	    if ($opt_V) {
		&Affiche_Var_Out ;
	    } elsif (defined($opt_html)) {
		if (defined($opt_fichier)) {
		    if ($#listebis) {
			&Affiche_Var_Html ;
			&Get_Var_Html ;
			use view::viewhtml ;
			&viewhtml::View_Core($opt_html,$outfile,$NumListe{$opt_fichier}) ;
		    } else {
			&Get_Var_Html ;
			use view::viewhtml ;
			&viewhtml::View_Core($opt_html,$outfile,$NumListe{$opt_fichier}) ;
		    }
		} else {
		    &Affiche_Var_Html ;
		}
	    } else {
		&Affiche_Var_In ;
	    }
	    if ($opt_p) {
		print STDOUT "$rec" if ($debug >= 1);
	    } 
	}
    } else {
        if ($debug >= 0) {
	    print STDOUT " *** Programme stopp: RECHERCHE INFRUCTUEUSE.\n" ;
	}
    }
    if ((@listehtm)||($opt_Y)) {
	&Html_Print ;
    }
}
#%###################################################
# Ecriture du fichier HTML du resultat de la recherche
sub Html_Print {
    if ($opt_Y) {
        if ($debug >= 3) {print STDOUT "Constitution du fichier '$opt_Y.html'.\n";}
        if (open(RESULTAT,"<$opt_Y.html")) {die "Refus de dtruire le fichier $opt_Y.html existant";}
	open(RESULTAT,">$opt_Y.html");
    } else {
        if ($debug >= 3) {print STDOUT "Fichier de rfrence html non constitue.\n";}
##	open(RESULTAT,">-") ;
	return ;
    }
    print RESULTAT  "<html><head>\n<title>Rsultat de la recherche de @listev </title>\n";
    print RESULTAT "</head>\n<body>\n<h1>Rsultat de la recherche de @listev </h1>\n";
    if ( @listebis ) {
	print RESULTAT "<ol>\n";
	foreach $file (@listebis) {
	    print RESULTAT "<li><A HREF=\"$file\">$file</A>\n" ;
	}
	print RESULTAT "</ol>\n";
    } else {
	print RESULTAT "La recherche n'a rien donn\n";
    }
    print RESULTAT "<BR>Les fichiers de recherche taient:\n";
    print RESULTAT "<ol>\n";
    foreach $file (@listerech) {
	print RESULTAT "<li><A HREF=\"$file\">$file</A>\n" ;
    }
    print RESULTAT "</ol>\n";
    if (@liste_exclu){
	print RESULTAT "<BR>Attention, les fichiers inclus suivants n'existent pas:\n";
	print RESULTAT "<ol>\n";
	foreach $file (@liste_exclu){
	    print RESULTAT "<li><A HREF=\"$file\">$file</A>\n" ;
	}
	print RESULTAT "</ol>\n";
    }
    print RESULTAT "</body></html>\n";
    close(RESULTAT);
}

#%###################################################
# Ajoute les noms de fichiers a rechercher
sub ETENDS {
    foreach $DIRECTOIRE (@_) {
        opendir MONDIRECTOIRE, $DIRECTOIRE or die "$DIRECTOIRE n'existe pas";
        @liste = grep /\.(c|cc|cpp|C|CC|c\+\+|C\+\+)$/, readdir(MONDIRECTOIRE);
        closedir MONDIRECTOIRE;
        foreach $file (@liste) {
            unless ($Connu{$file}) {
                $Connu{$file} = $file ;
                push(@listec,"$DIRECTOIRE/$file");
            }
        }
        opendir MONDIRECTOIRE, $DIRECTOIRE;
        @liste = grep /\.(f|f90)$/i, readdir(MONDIRECTOIRE);
        closedir MONDIRECTOIRE;
        foreach $file (@liste) {
            unless ($Connu{$file}) {
                $Connu{$file} = $file ;
                push(@listef,"$DIRECTOIRE/$file");
            }
        }
        opendir MONDIRECTOIRE, $DIRECTOIRE;
        @liste = grep /\.(h|hh|fh)$/i, readdir(MONDIRECTOIRE);
        closedir MONDIRECTOIRE;
        foreach $file (@liste) {
            unless ($Connu{$file}) {
                $Connu{$file} = $file ;
                push(@listehf,"$DIRECTOIRE/$file");
            }
        }
        opendir MONDIRECTOIRE, $DIRECTOIRE;
        @liste = grep /\.(tex|bib)$/, readdir(MONDIRECTOIRE);
        closedir MONDIRECTOIRE;
        foreach $file (@liste) {
            unless ($Connu{$file}) {
                $Connu{$file} = $file ;
                push(@listetex,"$DIRECTOIRE/$file");
            }
        }
        opendir MONDIRECTOIRE, $DIRECTOIRE;
        @liste = grep /\.(htm|html)$/, readdir(MONDIRECTOIRE);
        closedir MONDIRECTOIRE;
        foreach $file (@liste) {
            unless ($Connu{$file}) {
                $Connu{$file} = $file ;
                push(@listehtm,"$DIRECTOIRE/$file");
            }
        }
        opendir MONDIRECTOIRE, $DIRECTOIRE;
        @liste = grep /\.(tcl|tk)$/, readdir(MONDIRECTOIRE);
        closedir MONDIRECTOIRE;
        foreach $file (@liste) {
            unless ($Connu{$file}) {
                $Connu{$file} = $file ;
                push(@listetcl,"$DIRECTOIRE/$file");
            }
        }
        opendir MONDIRECTOIRE, $DIRECTOIRE;
        @liste = grep /\.(perl|pm)$/, readdir(MONDIRECTOIRE);
        closedir MONDIRECTOIRE;
        foreach $file (@liste) {
            unless ($Connu{$file}) {
                $Connu{$file} = $file ;
                push(@listeperl,"$DIRECTOIRE/$file");
            }
        }
    }
}

#%###################################################
# Determine les includes recursifs si necessaire dans le fortran, et les appelees.
sub Rech_Recursif_F {
    if ($debug >= 3) {print STDOUT "Recherche des fichiers fortran du site...\n";}
    $ITER=0;
    ${CB} = "c";
    ${CE} = "";
    @liste_exter = () ;
    @liste_exclu = () ;
    (@liste) = (@listef);
    while (@liste) {
    $ITER++;
        @liste_inclu = () ;
        @liste_appel = () ;
        foreach $file (@liste) {
            next unless &OPENFILE($DIRW,@GETIN_PATH);
            while(<FILE>) {
                if ( /call/i) { # pour accelerer la recherche
                    if ((/^\s+\bcall\b\s*(\w+)/i) || (/^\s*\d+\s*\bcall\b\s*(\w+)/i)) {
                        $Routine = $1 ;
                        $fichier = "$Routine.f" ;
                        unless ( $Nouveau{$fichier} ) {
                            $ligne=$_;
                            &APPEL_LISTE($DIRW,@GETIN_PATH);
                        }
                    }
                }
                if ( /include|input/i) { # pour accelerer la recherche
                    if (( /^\s*include\s*\'(.*)\'/i) || ( /^\s*include\s*\"(.*)\"/i)) {
# appels de include "
                        $fichier = $1 ;
                        if ( $fichier =~ /^\.\/(.*)/ ) {
                            $fichier = $1 ;
                        }
                        unless ( $Nouveau{$fichier} ) {
                            $ligne=$_;
                            &INCLU_LISTE($DIRW,@GETIN_PATH);
                        }
                    }
                    if ( /\\input\s*([\w_\/\.]+)/i) {
# appels de input
                        $fichier = $1 ;
                        if ( $fichier =~ /^\.\/(.*)/ ) {
                            $fichier = $1 ;
                        }
                        unless ( $Nouveau{$fichier} ) {
                            $ligne=$_;
                            ($FichierIsTrouve,$FichierFullName)=NEW_INCLU_LISTE($file,$fichier,$DIRW,@GETIN_PATH);
			    if ($FichierIsTrouve){
				push(@listetex,$FichierFullName);
				$Nouveau{$fichier}=$file ;
			    } else {
				push(@liste_exclu,$fichier);
				$Nouveau{$fichier}=$file ;
			    }

                        }
                    }
                }
            }
            close(FILE) ;
        }
        if ((@liste_appel) || (@liste_inclu)) {
            @liste = (@liste_appel,@liste_inclu) ;
            @listehf = (@listehf,@liste_inclu) ;
            @listef = (@listef,@liste_appel) ;
        } else {
            @liste = ();
        }
    }
    if (@listehf) {
        @listehf = sort @listehf ;
        if ($debug >= 3) {
            print STDOUT ($#listehf+1)." fichiers include fortran dtermins dans les ".($#listef+1)." fichiers fortran de recherche trouvs.\n";
	}
    } else {
        if ($debug >= 3) {
	    print STDOUT "Pas de fichiers include at Rech_Recursif_F dans ";
	}
        &Affiche_Liste(@listef);
    }
    if (@liste_exclu) {
    if ($debug >= 1) {print STDOUT "\t** Attention: absence des fichiers include\n\t @liste_exclu.\n";}
    }
    if (@liste_exter) {
    if ($debug >= 1) {print STDOUT "\t**Attention: routines de recherche rcursive non trouves:\n\t @liste_exter.\n";}
    }
}

#%###################################################
# Donne le nom absolu du repertoire a atteindre a partir du
# repertoire local locrep. La cible html est definie comme etant sur
# le repertoire newrep
sub GetNewRep {
    local($newrep,$locrep) = @_;
    if ($newrep =~ /^\//) {
       return $newrep;
   }
    while (($newrep)&&($newrep =~ /\.\.\/*(.*)/)) {
	$newrep = $1 ;
	$locrep = GetRepOf($locrep);
    }
    if ($newrep) {
	$newrep = $locrep."/".$newrep ;
    } else {
	$newrep = $locrep ;
    }
    $newrep ;
}

#%###################################################
# Determine les includes recursifs si necessaire dans le html.
sub Rech_Recursif_Rep {
    local(@oldliste) = @_ ;
    @liste = () ;
    $ITER++;
    if ($debug >= 3) {print STDOUT "Recherche $ITER des ".@_." rpertoires du site...\n";}
    foreach $repertoire (@oldliste){
#	$oldrep{$repertoire} = $repertoire ;
	if (opendir MONDIRECTOIRE, $repertoire) {
	    $localfile=GetRepOf($repertoire);
	    foreach $file (readdir(MONDIRECTOIRE)) {
		if ($file eq '.') {next;};
		if ($file eq '..') {next;};
		$file=GetNewRep($file,$localfile."/".&GetFicOf($repertoire));
		next unless -d $file;
		if (opendir LOCDIRECTOIRE, $file) {
#		    $oldrep{$file} = $file ;
		    push(@liste,$file);
		    push(@GETIN_PATH,$file);
		    closedir LOCDIRECTOIRE;
		}
	    }
	    closedir MONDIRECTOIRE;
	} else {
	    if ($debug >= 2) {print STDOUT "*+ $repertoire illisible\n";}
	}
    }
    if (@liste) {
	Rech_Recursif_Rep(@liste);
    }
}
#%###################################################
# Determine les includes recursifs si necessaire dans le html.
sub Rech_Recursif_Htm {
    if ($debug >= 3) {print STDOUT "Recherche des fichiers html du site...\n";}
    @internet = () ;
    @localnet = () ;
    %oldrep = () ;
    foreach $repertoire ($DIRW,@GETIN_PATH){
	$oldrep{$repertoire} = $repertoire ;
    }
    $ITER=0;
    ${CB} = "<\!";
# La ligne ci-dessus fait planter emacs...
    ${CE} = '>';
    @liste_exclu = () ;
    (@liste) = (@listehtm);
    while (@liste) {
    $ITER++;
if ($debug >= 3) {print STDOUT "Passe $ITER sur ".($#liste+1)." nouveaux fichiers, total ".($#listehtm+1)."...\n";}
        @liste_inclu = () ;
        foreach $file (@liste) {
            next unless &OPENFILE($DIRW,@GETIN_PATH);
	    $localfile = $FichierFullName ;
            while(<FILE>) {
                $ligne = $_;
                while ( $ligne =~ /(.*)<\!(.*)>(.*)/) { # On supprime les commentaires
                    $ligne = $1.$3;
                }
                if (($ligne =~ /(href|frame)/i) && (($ligne =~ /<A\s+HREF=["']*([\/\\\w,_\-:\.#-+]*)['"]*.*>/i) || ($ligne =~ /<FRAME\s+SRC=["']*([\/\\\w,_\-:\.#-+]*)['"]*.*>/i))) {
# Voici un hyper-lien
		    $lien=$1;
		    if ($lien =~ /^(http|ftp|filtered|mailto):(.*)/i){ # lien internet, on ne fait rien
			if ($2) { push(@internet,"$2"); }
                        $fichier="";
		    } elsif ($lien =~ /^file:(.*)/i){ # lien local
                        $fichier="$1";
		    } else {
                        $fichier="$lien";
		    }
                    if ($fichier){
			($fichier) = split ( /\#/, $fichier) ;
		    }
                    if ($fichier){
# le fichier de reference est obtenu en local a partir de 
# FichierFullName par la variable fichier
# locrep est le nom du repertoire local
# newrep est le nom d'un repertoire non connu.
#			($fichier) = split ( /\#/, $fichier) ;
			$locrep=GetRepOf($localfile);
			$newrep=GetRepOf($fichier);
			if ($newrep){
# normalement locrep est toujours defini
			    $newrep = GetNewRep($newrep,$locrep) ;
			    $fichier=$newrep."/".&GetFicOf($fichier);
			} else {
# Rfrence  un fichier local.
			    $fichier=$locrep."/".$fichier;
			}
# newrep est maintenant le nom absolu du repertoire a atteindre
			if (($newrep)&&!defined($oldrep{$newrep})){
# normalement locrep et newrep sont differents a ce niveau
			    if (opendir MONDIRECTOIRE, $newrep) {
				push(@localnet,$newrep);
				$oldrep{$newrep}=$newrep;
				closedir MONDIRECTOIRE;
			    }
			}
			if ($fichier ne "") {
			    unless ( $Nouveau{$fichier} ) {
				$file = $localfile ;
				&INCLU_LISTE($DIRW,@GETIN_PATH,@localnet);
			    }
			}
		    }
                }
            }
            close(FILE) ;
        }
        if (@liste_inclu) {
            @liste = (@liste_inclu) ;
            @listehtm = (@listehtm,@liste_inclu) ;
        } else {
            @liste = ();
        }
    }
    if (@listehtm) {
        @listehtm = sort @listehtm ;
        if ($debug >= 3) {
	    print STDOUT ($#listehtm+1)." fichiers locaux html dtermins";
	}
        @localnet=($DIRW,@GETIN_PATH,@localnet);
        if ($debug >= 3) {
	    print STDOUT " sur les ".($#localnet+1)." rpertoires.\n";
	}
    }
    if (@liste_exclu) {
        if ($debug >= 1) {
	    print STDOUT "\t** Attention: absence des fichiers html inclus\n\t @liste_exclu.\n";
	}
    }
}

#%###################################################
sub GetRepOf {
    if ( $_[0] =~ /(.*)\/.*?/ ) { $1; } ;
}
#%###################################################
sub GetFicOf {
    if ( $_[0] =~ /.*\/(.*)/ ) {
	$1;
    } else {
	$_[0];
    }
}
#			$fichier = GetFicOf($fichier,$file,$DIRW);
#%###################################################
sub GetFicOfLoc {
#| On veut le nom complet du fichier defini en relatif ou en absolu par
#| rapport a file, lui meme chemin absolu ou relatif. Le repertoire de base
#| est DIRW.
#| resultat=(si file relatif on prend DIRW et son relatif sinon racine file)+
#| (si fichier relatif on prend precedent et son relatif et son nom local sinon
#| on prend son nom absolu)
    if ($_[0] =~ /^\//) { # fichier est absolu
	$_[0];
    } else {
	if ($_[1] =~ /^\//) { # file est absolu
	    if ($_[1] =~ /(.*)\/(.*?)/ ) { # $1 est la racine, $2 est le nom local de fichier
		$1."/".$_[0]; # racine de file + fichier relatif
	    }
	} elsif ($_[1] =~ /(.*)\/(.*?)/ ) { # file relatif, avec racine
	    $_[2]."/".$1."/".$_[0]; # DIRW + racine relative de file + fichier relatif
	} else { # file ne sert a rien, uniquement nom de fichier local
	    $_[2]."/".$_[0]; # DIRW + fichier relatif
	}
    }
}
#%###################################################
# Determine les includes recursifs si necessaire dans le latex.
sub Rech_Recursif_Tex {
    if ($debug >= 3) {print STDOUT "Recherche des fichiers tex du site...\n";}
    $ITER=0;
    ${CB} = "%%";
    ${CE} = "";
    @liste_exclu = () ;
    (@liste) = (@listetex);
    while (@liste) {
    $ITER++;
        @liste_inclu = () ;
        foreach $file (@liste) {
            next unless &OPENFILE($DIRW,@GETIN_PATH);
            while(<FILE>) {
#               if ( /(.*?)!{\\}%.*/) { # On supprime les commentaires
                $ligne = $_;
                if ( $ligne =~ /(.*)(.)%(.*)/) { # On supprime les commentaires
                    if ("$2" eq "\\" ) { $ligne = $1.$3 ; } else { $ligne = $1; };
                } else {
                    $ligne = $_;
                }
                if ($ligne =~ /(include|input)/) { # presence du mot cle
# On recherche {\}(include\|input)\{.rep./fichier.ext\}
# en demandant le plus petit .rep./fichier avant un eventuel
# ".ext" a touver le plus grand possible avant \}
                    if (( $ligne =~ /\\(include|input){([\w\/\.]*?)(\.(\w+)){0,1}}/i)) {
                        if ($3) {
                            $fichier="$2$3";
                        } else {
                            $fichier="$2.tex";
                        }
                        unless ( $Nouveau{$fichier} ) {
                            &INCLU_LISTE($DIRW,@GETIN_PATH);
                        }
                    } elsif ( $ligne =~ /\\input ([\.\w\/]+)/i) {
                        $fichier = "$1" ;
                        unless ( $Nouveau{$fichier} ) {
                            $ligne=$_;
                            &INCLU_LISTE($DIRW,@GETIN_PATH);
                        }
                    }
                }
            }
            close(FILE) ;
        }
        if (@liste_inclu) {
            @liste = (@liste_inclu) ;
            @listetex = (@listetex,@liste_inclu) ;
        } else {
            @liste = ();
        }
    }
    if (@listetex) {
        @listetex = sort @listetex ;
        if ($debug >= 3) {
	    print STDOUT ($#listetex+1)." fichiers include latex dtermins.\n";
	}
    }
    if (@liste_exclu) {
        if ($debug >= 1) {
	    print STDOUT "\t** Attention: absence des fichiers include\n\t @liste_exclu.\n";
	}
    }
}

#%###################################################
# Tentative d'ouverture de fichier sur les repertoires
# de la variable \verb+GETIN_PATH+.
sub OPENFILE {
    $FichierFullName = "$file";
    $FichierIsTrouve = 1;
    if (open(FILE,$file)) {
        unless ($file =~ /^\//) { $FichierFullName = "$DIRW/$file"; }
    } else {
        $FichierIsTrouve = 0;
        foreach $DIRECTOIRE (@_) {
            if (open(FILE,"$DIRECTOIRE/$file")) {
                if ($DIRECTOIRE ne $DIRW) {
                    $file = "$DIRECTOIRE/$file" ;
		    $FichierFullName = "$DIRECTOIRE/$file" ;
                }
                $FichierIsTrouve = 1;
            }
        }
        unless ($FichierIsTrouve){
            print STDOUT " ** Fichier source $file\n inexistant sur @_ \n";
	    return 0;
        }  
    }
    if ($ITER ==1) { &IniToX ; };
    return 1;
}
#%###################################################
# Tentative d'ouverture de fichier sur les repertoires
# de la variable \verb+GETIN_PATH+.
sub OPENFICHIER {
    $FichierIsTrouve = 1;
    unless (open(FICHIER,$fichier)) {
        $FichierIsTrouve = 0;
        foreach $DIRECTOIRE (@_) {
            if (open(FICHIER,"$DIRECTOIRE/$fichier")) {
                if ($DIRECTOIRE ne $DIRW) {
                    $fichier = "$DIRECTOIRE/$fichier"
                    }
                $FichierIsTrouve = 1;
            }
        }
        unless ($FichierIsTrouve){
            print STDOUT " *** Fichier source $fichier:\n inexistant sur @_ \n";
	    return 0;
        }  
    }
    return 1;
}

#%###################################################
# Recherche des includes recursifs sur les repertoires
# de la variable \verb+GETIN_PATH+.
sub NEW_INCLU_LISTE {
    local($file,$fichier,@REPERTOIRES) = @_;
    local($FichierIsTrouve,$FichierFullName) = (0,$fichier);
    if (open(FICHIER,"$fichier")) {
        close(FICHIER) ;
        $FichierIsTrouve = 1;
    } else {
        foreach $DIRECTOIRE (@REPERTOIRES) {
            if (open(FICHIER,"$DIRECTOIRE/$fichier")) {
                close(FICHIER) ;
                $FichierIsTrouve = 1;
                $FichierFullName = "$DIRECTOIRE/$fichier";
            }
        }
    }
    &CatToX ;
    return ($FichierIsTrouve,$FichierFullName);
}

#%###################################################
# Recherche des includes recursifs sur les repertoires
# de la variable \verb+GETIN_PATH+.
sub INCLU_LISTE {
    $FichierIsTrouve = 0;
    if (open(FICHIER,"$fichier")) {
        push(@liste_inclu,"$fichier");
        $Nouveau{$fichier}=$file ;
        close(FICHIER) ;
        $FichierIsTrouve = 1;
        $FichierFullName = "$fichier";
    } else {
        foreach $DIRECTOIRE (@_) {
            if (open(FICHIER,"$DIRECTOIRE/$fichier")) {
                push(@liste_inclu,"$DIRECTOIRE/$fichier");
                $Nouveau{$fichier}=$file ;
                close(FICHIER) ;
                $FichierIsTrouve = 1;
                $FichierFullName = "$DIRECTOIRE/$fichier";
            }
        }
        unless ($FichierIsTrouve){
            push(@liste_exclu,$fichier);
            $Nouveau{$fichier}=$file ;
        }  
    }
    &CatToX ;
}

#%###################################################
# Recherche des includes recursifs sur les repertoires
# de la variable \verb+GETIN_PATH+.
sub IS_FICHIER_READABLE {
    local($fichier,@PATH)=@_;
    local($FichierIsTrouve) = 0;
    local($FichierFullName) = "";
    if (open(FICHIER,"$fichier")) {
        close(FICHIER) ;
        $FichierIsTrouve = 1;
        $FichierFullName = "$fichier" ;
    } else {
        foreach $DIRECTOIRE (@PATH) {
            if (open(FICHIER,"$DIRECTOIRE/$fichier")) {
                close(FICHIER) ;
                $FichierIsTrouve = 1;
                $FichierFullName = "$DIRECTOIRE/$fichier" ;
		last;
            }
        }
    }
    return ($FichierIsTrouve,$FichierFullName);
}
#%###################################################
# Recherche des includes recursifs sur les repertoires
# de la variable \verb+GETIN_PATH+.
sub APPEL_LISTE {
    (@PATH)=@_;
    ($FichierIsTrouve,$FichierFullName)=IS_FICHIER_READABLE($fichier,@PATH);
    unless ($FichierIsTrouve){
	$fichier =~ tr/A-Z/a-z/ ;
	($FichierIsTrouve,$FichierFullName)=IS_FICHIER_READABLE($fichier,@PATH);
    }
    if ($FichierIsTrouve){
	unless ($Nouveau{$fichier}) {
	    $Nouveau{$fichier}=$file ;
	    push(@liste_appel,"$FichierFullName"); #fichier
	}
    } else {
	push(@liste_exter,$fichier);
	$Nouveau{$fichier}=$file ;
    }
    &CatToX ;
}
#%###################################################
sub CatToX {
    if (($FichierIsTrouve)&&($opt_X)) {
        $RC= quotemeta "$_" ;
#TMP        $loc=`cat $FichierFullName`; 
        chop ($RR = $RC);
        $XC =~ s/${RC}/${CB}${RR}${CE}\n${loc}/ ;
#        $XC =~ s/${RC}/${loc}/ ;
    }
}
#%###################################################
sub IniToX {
    unless ($Nouveau{$FichierFullName}){
    if (($FichierIsTrouve)&&($opt_X)) {
#TMP        $loc=`cat $file`; 
        $XC .= $loc ;
    }}
}

#%###################################################
# Determine les includes recursifs si necessaire dans le fortran.
sub Rech_Includes_F {
    if ($debug >= 3) {print STDOUT "Recherche des includes fortran du site...\n";}
    ${CB} = "c";
    ${CE} = "";
    $ITER=0;
    (@liste) = (@listef);
    @liste_exclu = () ;
    while (@liste) {
    $ITER++;
        @liste_inclu = () ;
        foreach $file (@liste) {
            next unless &OPENFILE($DIRW,@GETIN_PATH);
            while(<FILE>) {
                if ( /include|input/i) { # pour accelerer la recherche
                    if (( /^\s+include\s+\'(.*)\'/i) || ( /^\s+include\s+\"(.*)\"/i)) {
# appels de include "
                        $fichier = $1 ;
                        if ( $fichier =~ /^\.\/(.*)/ ) {
                            $fichier = $1 ;
                        }
                        unless ( $Nouveau{$fichier} ) {
                            $ligne=$_;
                            &INCLU_LISTE($DIRW,@GETIN_PATH);
			}
                    }
                    if ( /\\input\s*([\w_\/\.]+)/i) {
                        $fichier = $1 ;
                        if ( $fichier =~ /^\.\/(.*)/ ) {
                            $fichier = $1 ;
                        }
                        unless ( $Nouveau{$fichier} ) {
                            $ligne=$_;
                            ($FichierIsTrouve,$FichierFullName)=NEW_INCLU_LISTE($file,$fichier,$DIRW,@GETIN_PATH);
			    if ($FichierIsTrouve){
				push(@listetex,$FichierFullName);
				$Nouveau{$fichier}=$file ;
			    } else {
				push(@liste_exclu,$fichier);
				$Nouveau{$fichier}=$file ;
			    }
                        }
                    }
                }
            }
            close(FILE) ;
        }
        if (@liste_inclu) {
            @liste = @liste_inclu ;
            @listehf = (@listehf,@liste_inclu) ;
        } else {
            @liste = ();
        }
    }
    if (@listehf) {
        @listehf = sort @listehf ;
        if ($debug >= 3) {
	    print STDOUT ($#listehf+1)." fichiers include fortran dtermins.\n";
	}
        if (@liste_exclu) {
            if ($debug >= 1) {print STDOUT "\t** Attention: absence des fichiers include\n\t @liste_exclu.\n";}
        }
    } else {
        if (@liste_exclu) {
            if ($debug >= 1) {print STDOUT "\t** Attention: absence des fichiers include\n\t @liste_exclu.\n";}
            if ($debug >= 1) {print STDOUT "\t demands par le(s) fichier(s) fortran\n\t ";}
            if ($debug >= 1) {&Affiche_Liste(@listef);}
        }
    }
}

#%###################################################
# Determine les includes recursifs si necessaire dans le C.
sub Rech_Includes_C {
    if ($debug >= 3){print STDOUT "Recherche des includes C du site...\n";}
    ${CB} = "\/\*";
    ${CE} = "\*\/";
    $ITER=0;
    (@liste) = (@listec);
    @liste_exclu = () ;
    while (@liste) {
        $ITER++;
        @liste_inclu = () ;
        foreach $file  (@liste) {
            next unless &OPENFILE($DIRW,@GETIN_PATH);
            $comm = 0;
            while(<FILE>) {
                $ligne=$_;
#               &GetLigne ;
                $commentaire = "";
                $instruction = "";
                &Instruction_Commentaire_CC;
                if (($instruction) && ($instruction =~ /include|input/)) {
                    if ( $instruction =~ /^\#include\s*\"(.*)\"/i) {
# appels de include "
                        $fichier = $1 ;
                        if ( $fichier =~ /^\.\/(.*)/ ) {
                            $fichier = $1 ;
                        }
                        unless ( $Nouveau{$fichier} ) {
                            $ligne=$_;
                            &INCLU_LISTE($DIRW,@GETIN_PATH);
                        }
                    }
                    if ( $instruction =~ /\\input\s*([\w_\/\.]+)/) {
# appels de include "
                        $fichier = $1 ;
                        if ( $fichier =~ /^\.\/(.*)/ ) {
                            $fichier = $1 ;
                        }
                        unless ( $Nouveau{$fichier} ) {
                            $ligne=$_;
                            ($FichierIsTrouve,$FichierFullName)=NEW_INCLU_LISTE($file,$fichier,$DIRW,@GETIN_PATH);
			    if ($FichierIsTrouve){
				push(@listetex,$FichierFullName);
				$Nouveau{$fichier}=$file ;
			    } else {
				push(@liste_exclu,$fichier);
				$Nouveau{$fichier}=$file ;
			    }
                        }
                    }
                }
            }
            close(FILE) ;
        }
        if (@liste_inclu) {
            @liste = @liste_inclu ;
            @listehc = (@listehc,@liste_inclu) ;
        } else {
            @liste = ();
        }
    }
    if (@listehc) {
        @listehc = sort @listehc ;
        if ($debug >= 3) {
	    print STDOUT ($#listehc+1)." fichiers include C dtermins.\n";
	}
        if (@liste_exclu) {
            if ($debug >= 1) {print STDOUT "\t** Attention: absence des fichiers include\n\t@liste_exclu.\n";}
        }
    } else {
        if (@liste_exclu) {
            if ($debug >= 1) {print STDOUT "\t** Attention: absence des fichiers include\n\t @liste_exclu.\n";}
            if ($debug >= 1) {print STDOUT "\t demands par le(s) fichier(s) C\n\t ";}
            if ($debug >= 1) {
		&Affiche_Liste(@listec);
	    }
        }
    }
}

#%###################################################
# Enlever les commentaires du C
sub Instruction_Commentaire_CC {
    if ( $ligne =~ /(.*)(\/\*)(.*)(\*\/)(.*)/ ) { # comment. complet
        if ($comm) {
            $commentaire .= $1.$3.$4 ;
            $instruction .= $5 ;
            $comm=0;
        }else{
            $commentaire .= $2.$3.$4 ;
            $instruction .= $1.$5 ;
        }
    } elsif ( $ligne =~ /(.*)(\/\*)(.*)/ ) { # debut de commentaire
        if ($comm) {
            $commentaire .= $1.$3 ;
        }else{
            $instruction .= $1 ;
            $commentaire .= $2.$3 ;
        }
        $comm=1;
    } elsif ( $ligne =~ /(.*)(\*\/)(.*)/ ) { # fin de commentaire
        $comm=0;
        $commentaire .= $1.$2 ;
        $instruction .= $3 ;
    } elsif ($comm) { # a mettre en commentaire
        $commentaire .= $ligne."\n" ;
    } elsif ( $ligne =~ /(.*)(\/\/)(.*)/ ) { # debut et fin de commentaire
        if ($comm) {
            $commentaire .= $1.$3 ;
        } else {
            $comm=0;
            $instruction .= $1 ;
            $commentaire .= $2.$3 ;
        }
    } else { # a mettre en instruction
        $instruction .= $ligne ;
    }
} ;

#%###################################################
sub GetLigne {
    $nextligne = $ligne ;
    $ligne = "\n" ;
    while (($nextligne) && ( "$nextligne" ne "$ligne" )) {
        $ligne = "$nextligne" ;
        if ( $ligne =~ /(.*?)\/\*(.*?)\*\/(.*)/g ) {
            $nextligne = $1.$3;
        } elsif ( $comm == 1 ) {
            if ( $ligne =~ /\*\/(.*)/ ) {
                $nextligne = $2 ;
                $comm = 0 ;
            }
        } elsif ( $comm == 0 ) {
            if ( $ligne =~ /(.*?)\/\*/ ) {
                $nextligne = $1."" ;
                $comm = 1 ;
            }
        }
    }
    unless ($nextligne) {
        $ligne = "" ;
    }
}

#%###################################################
sub Rech_Var_Tex { # Recherche des variables dans les fichiers latex
    foreach $variable (@listev) {
        foreach $fichier (@listetex) {
            next unless &OPENFICHIER($DIRW,@GETIN_PATH);
            while(<FICHIER>) {
                if ( /$variable/i) {
                    if ($NumListe{$fichier}) {
                        $NumListe{$fichier} .= ":$." ;
                    } else {
                        $NumListe{$fichier} = "$." ;
                        push(@listebis,$fichier);
                    }
                }
            }
            close(FICHIER) ;
        }
    }
    unless (@listebis) {
        if ($debug >= 2) {print STDOUT "Aucun segment de variable (@listev) trouv dans la liste de recherche ";}
        if ($debug >= 2) {&Affiche_Liste(@listetex);}
    }
}

#%###################################################
sub Rech_Var_In_Occ { # Recherche des variables dans les fichiers concernes
    foreach $variable (@listev) {
        foreach $fichier (@listerech) {
            next unless &OPENFICHIER($DIRW,@GETIN_PATH);
            while(<FICHIER>) {
                if ( /$variable/i) {
                    if ($NumListe{$fichier}) {
                        $NumListe{$fichier} .= ":$." ;
                    } else {
                        $NumListe{$fichier} = "$." ;
                        push(@listebis,$fichier);
                    }
                }
            }
            close(FICHIER) ;
        }
    }
    unless (@listebis) {
        if ($debug >= 2) {print STDOUT "Aucun segment de variable (@listev) trouv dans la liste de recherche ";}
        if ($debug >= 2) {&Affiche_Liste(@listerech);}
    }
}

#%###################################################
sub Rech_Var_In_Perl { # Recherche des variables dans les fichiers concernes
    if ($debug >= 3) {print STDOUT "\t\tRech_Var_In_Perl('${variable_p}')\n";};
    $rec="";
    %p_rec = () ;
        foreach $fichier (@listerech) {
            next unless &OPENFICHIER($DIRW,@GETIN_PATH);
            while(<FICHIER>) {
                if ( /\b(${variable_p})\b/) {
		if (($1) && (!$p_rec{$1})) {
		    $p_rec{$1}="$fichier:$.:$_";
		    $rec .= $1."\n" ;
		}
                    if ($NumListe{$fichier}) {
                        $NumListe{$fichier} .= ":$." ;
                    } else {
                        $NumListe{$fichier} = "$." ;
                        push(@listebis,$fichier);
                    }
                }
            }
            close(FICHIER) ;
        }
    unless (@listebis) {
        if ($debug >= 2) {print STDOUT "Aucun segment de variable (@listev) trouv dans la liste de recherche ";}
        if ($debug >= 2) {&Affiche_Liste(@listerech);}
    }
}

#%###################################################
# Recherche des variables dans les commentaires fortran...
sub Fortran_Commentaire {
    local(@listerech)=@_;
    local(@listebis)=();
    foreach $variable (@listev) {
        foreach $fichier (@listerech) {
            next unless &OPENFICHIER($DIRW,@GETIN_PATH);
            while(<FICHIER>) {
		if ($opt_f) {
		    next if Fortran_Comment($_); # Commentaire
		} elsif ($opt_F) {
		    next unless Fortran_Comment($_); # Commentaire
		}
                if (( /$variable/i) && ( /\b$variable\b/i)) { # Accelere la recherche
                    if ($NumListe{$fichier}) {
                        $NumListe{$fichier} .= ":$." ;
                    } else {
                        $NumListe{$fichier} = "$." ;
                        push(@listebis,$fichier);
                    }
                }
            }
            close(FICHIER) ;
        }
    }
    unless (@listebis) {
        if ($debug >= 2) {print STDOUT "Aucune variable liste (@listev) trouve dans la liste de recherche:\n";}
        if ($debug >= 2) {&Affiche_Liste(@listerech);}
    }
    return (@listebis);
}

#%###################################################
# Retourne : comm si c'est un commentaire,
#            instruction les instructions de la ligne
#            commentaire les commentaires de la ligne
#            la ligne nettoye...
sub C_Comment { # Status: dbuggue...
    local($comm,$ligne)=@_;
    local($commentaire,$instruction)=("","");
    while ( $ligne =~ /(.*?)\/\*(.*?)\*\/(.*)/ ) { # comment. complet 1/*2*/3
        if ($comm) { # On est dj dans les commentaires: /*x1/*2*/3
            $commentaire = $1.'/*'.$2 ;
	    $ligne = $3;
            $comm=0;
        } else { # Cela commence les commentaires... et les termine.
            $commentaire .= $2;
            $instruction .= $1 ;
	    $ligne = $3;
        }
    }
    if ($ligne) { # debut de commentaire
    if ( $ligne =~ /(.*)\/\*(.*)/ ) { # debut de commentaire
        if ($comm) { # On n'a pas vu un CB-CE
            $commentaire = $1.'/*'.$2 ;
        } else {
            $instruction .= $1 ;
            $commentaire .= $2 ;
	    $comm=1;
        }
    } elsif ( $ligne =~ /(.*)\*\/(.*)/ ) { # fin de commentaire
        $comm=0;
        $commentaire .= $1 ;
        $instruction .= $2 ;
    } elsif ($comm) { # a mettre en commentaire
        $commentaire = $ligne ;
    } elsif ( $ligne =~ /(.*)\/\/(.*)/ ) { # debut et fin de commentaire
        if ($comm) {
            $commentaire = $1.'//'.$2 ;
        } else {
            $instruction .= $1 ;
            $commentaire .= $2 ;
        }
    } else { # a mettre en instruction
        $instruction .= $ligne ;
    }
    }
    return ($comm, $ligne, $instruction, $commentaire);
}

#%###################################################
# Recherche des variables dans les commentaires fortran...
sub C_Commentaire {
    local(@listerech)=@_;
    local(@listebis)=();
    foreach $variable (@listev) {
        foreach $fichier (@listerech) {
            next unless &OPENFICHIER($DIRW,@GETIN_PATH);
	    $comm=0;
	    $OK=0;
            while(<FICHIER>) {
		($comm,$ligne,$instruction,$commentaire)=C_Comment($comm,$_);
		if ($opt_f) {
                if (( $instruction =~ /$variable/i) && ( $instruction =~/\b$variable\b/i)) {
		    $OK=1;
		}}
		if ($opt_F) {
                if (( $commentaire =~ /$variable/i) && ( $commentaire =~/\b$variable\b/i)) {
		    $OK=1;
		}}
		if ($OK) {
                    if ($NumListe{$fichier}) {
                        $NumListe{$fichier} .= ":$." ;
                    } else {
                        $NumListe{$fichier} = "$." ;
                        push(@listebis,$fichier);
                    }
		    $OK=0;
                }
            }
            close(FICHIER) ;
        }
    }
    unless (@listebis) {
        if ($debug >= 2) {print STDOUT "Aucune variable liste (@listev) trouve dans la liste de recherche:\n";}
        if ($debug >= 2) {&Affiche_Liste(@listerech);}
    }
    return (@listebis);
}

#%###################################################
# Recherche des variables en tant que mot
sub Rech_Var_In_W {
    foreach $variable (@listev) {
        foreach $fichier (@listerech) {
            next unless &OPENFICHIER($DIRW,@GETIN_PATH);
            while(<FICHIER>) {
                if (( /$variable/i) && ( /\b$variable\b/i)) { # Accelere la recherche
                    if ($NumListe{$fichier}) {
                        $NumListe{$fichier} .= ":$." ;
                    } else {
                        $NumListe{$fichier} = "$." ;
                        push(@listebis,$fichier);
                    }
                }
            }
            close(FICHIER) ;
        }
    }
    unless (@listebis) {
        if ($debug >= 2) {print STDOUT "Aucune variable liste (@listev) trouve dans la liste de recherche:\n";}
        if ($debug >= 2) {&Affiche_Liste(@listerech);}
    }
}

#%###################################################
# enleve le prefixe du rpertoire... affichage raccourci.
sub Affiche_Liste {
    local($REPERTOIREOLD) = "";
    foreach $file (sort @_) {
        if (($REPERTOIRE=GetRepOf($file)) && ($REPERTOIRE ne $REPERTOIREOLD)) {
	    print STDOUT "\n\t\t:$REPERTOIREOLD.\n" if $REPERTOIREOLD ;
	    print STDOUT "Rpertoire: $REPERTOIRE\n" ;
	    print STDOUT "Fichiers:";
	    $REPERTOIREOLD = $REPERTOIRE;
        }
	if ($opt_E) {
	    print STDOUT "\n".$file." :1";
	} elsif ($opt_C) {
	    print STDOUT "\n"."line 1 of ".$file.":";
	} else {
	    print STDOUT " ".GetFicOf($file);
	}
   }
    if ($debug >= 1) {
	print STDOUT "\n\t\t:$REPERTOIRE." if $REPERTOIRE ;
    }
    print STDOUT "\n" ;
}

#%###################################################
# Recherche des declarations de variables in C
sub A_Rech_Var_In_Wdec_CC {
    foreach $variable (@listev) {
        foreach $fichier (@listec,@listehc) { # Recherche dans le C
            next unless &OPENFICHIER($DIRW,@GETIN_PATH);
            $OK=0;
            $Numero=0;
            while(defined($ligne=<FICHIER>)) {
                chop($ligne);
                $commentaire = "";
                $instruction = "" ;
                &Instruction_Commentaire_CC;
##                if ( $instruction =~ /\b(float|int|double|char|extern|long|register|short|static|struct|typedef|unsigned|void|define)\b/i) {
                if ( $instruction =~ /\b(${listeofckeys})\b/i) {
                    $OK=1;
                    $Numero=$.;
                }
                if ($OK) {
                    if ( $instruction =~ /\b$variable\b/i) {
                        if ($Numero) {
                            $Ecrit = "$Numero:$." ;
                            $Numero = 0 ;
                        } else {
                            $Ecrit = "$." ;
                        }
                        if ($NumListe{$fichier}) {
                            $NumListe{$fichier} .= ":$Ecrit" ;
                        } else {
                            $NumListe{$fichier} = "$Ecrit" ;
                            push(@listebis,$fichier);
                        }
                    }
                }
                if ($OK) {
                    if ( $instruction =~ /;/ ) {
                        $OK = 0 ;
                    } elsif ($instruction =~ /\b(define)\b/i) {
                        $OK = 0 ;
                    }
                }
            }
            close(FICHIER);
        }
    }
}
#%###################################################
# Detection des commentaires du fortran
sub Instruction_Commentaire_F {
    if (( $ligne =~ /^[^\s]/i) && ( $ligne =~ /^[^\d]/i)) { # comment
        $commentaire .= $ligne;
    } else {
        if ( $ligne =~ /.{6}(.*)/ ) {
            $instruction .= $1 ;
# La ligne ci-dessous introduit des bugs: DEC VAR devenait DECVAR=ABSURD.
#            $instruction =~ s/ //g ;
        } else {
            $instruction .= $ligne ;
        }
    }
}

#%###################################################
# Retourne si la ligne est un commentaire fortran
sub Fortran_Comment {
    local($ligne)=@_;
    if (( $ligne =~ /^[^\s]/i) && ( $ligne =~ /^[^\d]/i)) {
	return 1; # valeur true
    } else {
	return 0; # valeur false
    }
}

#%###################################################
# Retourne si la ligne est une dclaration fortran ou un call
sub Fortran_Header {
    local($ligne)=@_;
    if ($ligne =~ /\b(subroutine|function|call)\b/i) {
	return 1; # valeur true
    } else {
	return 0; # valeur false
    }
}

#%###################################################
# Retourne true si la ligne affecte la variable.
sub Find_Egal {
    local($ligne,$variable)=@_;
    while ( $ligne =~ /(.*)\(.*\)(.*)/) {
	if (($1)&&($2)) {
	    $ligne=$1.$2;
	} else {
	    $ligne=$1;
	}
    }
    if ( $ligne =~ /\b$variable\b.*=/i) {
	return 1; # true
    } else {
	return 0; # false
    }
}

#%###################################################
# Retourne true si la ligne est une ligne de continuation fortran
# et la ligne de continuation sans son dbut, retourne false sinon.
sub Fortran_Continued {
    local($ligne)=@_;
    chop($ligne);
    if ( $ligne =~ /^.{5}\S(.*)/) {
	return (1,$1); # true
    } else {
	return (0,$ligne); # false
    }
}

#%###################################################
# Retourne le nombre de parenthses ouvertes d'aprs
# l'ancienne valeur de "ouvert" et la ligne courante.
sub Parenthesis_Open {
    local($ligne,$ouvert)=@_;
    if ($ligne =~ /(.*)\((.*)\)(.*)/) {
	$ligne = $1.$2.$3 ;
	if ($ouvert == 0) { $ouvert=-1; } ; # ruse...
    }
    while ($ligne =~ /(.*)\((.*)\)(.*)/) { $ligne = $1.$2.$3 ;};
    if ($ligne =~ /\(/) {
	if ($ouvert == -1) { $ouvert=0; } ; # ruse...
	$ouvert++ ;
    }
    if ($ligne =~ /\)/) {
	$ouvert-- ;
	if ($ouvert == 0) { $ouvert=-1; } ; # ruse...
    }
    return $ouvert ;
}

#%###################################################
# Retourne true si la ligne affecte la variable par une cl...
sub Find_Affecte_Key {
    local($ligne,$variable,$listeoffkeys)=@_;
    if ( $ligne =~ /\b(pointer|equivalence|parameter)\b/i) {
	while ( $ligne =~ /\b(pointer|equivalence|parameter\b.*?)\s*\(\s*([\w]+).*?,\s*([\w]+).*?\)(.*)/i) {
	    $ligne=$1." $2,$3 " ;
	    $ligne.=$4 if $4;
	}
    } else {
	while ( $ligne =~ /(.*)\(.*\)(.*)/) {
	    if (($1)&&($2)) {
		$ligne=$1.$2;
	    } else {
		$ligne=$1;
	    }
	}
    }
##                if ( /\b(${listeoffkeys})\b/i) {
    if ( $ligne =~ /\b(${listeoffkeys}).*\b$variable\b/i) {
	return 1; # true
    } else {
	return 0; # false
    }
}

#%###################################################
# Recherche des declarations de variables en fortran
sub A_Rech_Var_In_Wdec_F {
    local(@listebis)=();
    foreach $variable (@listev) {
	&Fortran_Declaration(@listef,@listehf);
    }
    if (@listebis) {
	if ($debug >= 4) {
	    print STDOUT "\t\tA_Rech_Var_In_Wdec_F found match.\n";
	}
    } elsif ($debug >= 2) {
        print STDOUT "A_Rech_Var_In_Wdec_F found no match for (@listev) in\n";
        &Affiche_Liste(@listef,@listehf);
    }
    return (@listebis);
}
#%###################################################
# Recherche des declarations de variables en fortran
sub Fortran_Declaration {
    local(@listefile)=@_;
    foreach $fichier (@listefile) { # Recherche dans le fortran
	next unless &OPENFICHIER($DIRW,@GETIN_PATH);
	$OK=0; $Numero=0; $ouvert=0;
	while(<FICHIER>) {
	    next if Fortran_Comment($_); # Commentaire
	    unless ($OK) {
		($OK)=Fortran_Find_Key($_,$listeoffkeys); # vrai si variable trouve
	    }
	    next unless $OK; # Acclration des recherches...
	    if (($OK) && !($Numero)) { # vrai si ok et numero faux
		$Numero=$.; $ouvert=1; $Ecrit=0; chop($ligne=$_) ;
	    } elsif ($OK) { # ligne suivante
		($ouvert,$addedligne)=Fortran_Continued($_);
		if ($ouvert) { # La ligne continue
		    $ligne .= $addedligne;
		} else {
		    if ($Ecrit) { # Un match s'est produit...
			if ($NumListe{$fichier}) {
			    $NumListe{$fichier} .= ":$Numero" ;
			} else {
			    $NumListe{$fichier} = "$Numero" ;
			    push(@listebis,$fichier);
			}
		    }
		    $Numero=0; # remise  zro mais il faut reboucler !!!
		    if (($OK)=Fortran_Find_Key($addedligne,$listeoffkeys)) {
			$ouvert=1; $Ecrit=0; $Numero=$.; $ligne=$addedligne;
		    }
		}
	    }
	    if ($ouvert) { # on teste l'affectation de variable
		$Numero .= ":$." ;
		if ($variable) {
		    if (Find_Affecte_Key($ligne,$variable,$listeoffkeys)) { 
			$Ecrit = 1 ; # la variable est affecte.
		    }
		} else {
		    $Ecrit = 1 ;
		}
	    }
	}
	close(FICHIER);
    }
}

#%###################################################
# Retourne true si la ligne contient la variable.
sub Fortran_Find_Match {
    local($ligne,$variable)=@_;
    if ( $ligne =~ /\b$variable\b/i) {
	while ( $ligne =~ /(.*)".*"(.*)/i) { # On enlve les strings
	    $ligne=$1.$2;
	}
	while ( $ligne =~ /(.*)'.*'(.*)/i) { # On enlve les strings
	     $ligne=$1.$2;
	}
	if ( $ligne =~ /\b$variable\b/i) {
	    return 1; # true
	}
    } else {
	return 0; # false
    }
}

#%###################################################
# Retourne true si la ligne contient une des variables.
sub Fortran_Find_Key {
    local($ligne,$listeoffkeys)=@_;
    if ( /\b($listeoffkeys)\b/i) {
	while ( $ligne =~ /(.*)".*"(.*)/i) { # On enlve les strings
	    $ligne=$1.$2;
	}
	while ( $ligne =~ /(.*)'.*'(.*)/i) { # On enlve les strings
	    $ligne=$1.$2;
	}
	if ( $ligne =~ /\b($listeoffkeys)\b/i) {
	    return 1; # true
	}
    }
    return 0; # false
}

#%###################################################
# Retourne true si la ligne contient une des variables.
sub Fortran_Find_Special {
    local($ligne,$listeoffkeys)=@_;
    if ( /($listeoffkeys)/i) {
	while ( $ligne =~ /(.*)".*"(.*)/i) { # On enlve les strings
	    $ligne=$1.$2;
	}
	while ( $ligne =~ /(.*)'.*'(.*)/i) { # On enlve les strings
	    $ligne=$1.$2;
	}
	if ( $ligne =~ /($listeoffkeys)/i) {
	    return 1; # true
	}
    }
    return 0; # false
}

#%###################################################
# Retourne true si la ligne affecte utilise la variable pour affecter qqch...
sub Find_Affecte_Droite {
    local($ligne,$variable,$listeoffkeys)=@_;
    if ( $ligne =~ /(${listeoffkeys}).*\b$variable\b/i) {
	return 1; # true
    } else {
	return 0; # false
    }
}

#%###################################################
# Recherche des affectations o la variable sert  droite de
# l'expression.
sub Rech_Var_In_WRightEgal {
    local(@listebis)=();
    local($listeoffkeys)= quotemeta '='; # quotemeta
    foreach $variable (@listev) {
        foreach $fichier (@listef,@listehf) { # Recherche dans le fortran
            next unless &OPENFICHIER($DIRW,@GETIN_PATH);
            $OK=0; $Numero=0; $ouvert=0;
            while(<FICHIER>) {
		next if Fortran_Comment($_); # Commentaire
		unless ($OK) { ($OK)=Fortran_Find_Special($_,$listeoffkeys); };
		next unless $OK; # Acclration des recherches...
		if (($OK) && !($Numero)) { $Numero=$.; $ouvert=1; $Ecrit=0; chop($ligne=$_);
		} elsif ($OK) {
		    ($ouvert,$addedligne)=Fortran_Continued($_);
		    if ($ouvert) { $ligne .= $addedligne;
		    } else {
			if ($Ecrit) { # Un match s'est produit...
			    if ($NumListe{$fichier}) { $NumListe{$fichier} .= ":$Numero" ;
			    } else {
				$NumListe{$fichier} = "$Numero" ;
				push(@listebis,$fichier);
			    }
			}
			$Numero=0; # remise  zro mais il faut reboucler !!!
			if (($OK)=Fortran_Find_Special($addedligne,$listeoffkeys)) {
			    $ouvert=1; $Ecrit=0; $Numero=$.; chop($ligne=$_);
			}
		    }
		}
		if ($ouvert) { # on teste l'affectation de variable
		    $Numero .= ":$." ;
		    if (Find_Affecte_Droite($ligne,$variable,$listeoffkeys)) { 
			$Ecrit = 1 ; # la variable est affecte.
		    }
		}
            }
            close(FICHIER);
	}
    }
    unless (@listebis) {
        if ($debug >= 2) {print STDOUT " Rech_Var_In_WRightEgal found no match for (@listev) in\n";}
        if ($debug >= 2) {&Affiche_Liste(@listef,@listehf);}
    }
    return (@listebis);
}

#%###################################################
# Affectation de variable par le fortran.
sub Fortran_Egal {
    local(@listebis)=();
    foreach $variable (@listev) {
        foreach $fichier (@listef,@listehf) { # Recherche dans le fortran
            next unless &OPENFICHIER($DIRW,@GETIN_PATH);
            $OK=0; $Numero=0; $ouvert=0;
            while(<FICHIER>) {
		next if Fortran_Comment($_); # Commentaire
		unless ($OK) {
		    ($OK)=Fortran_Find_Match($_,$variable); # vrai si variable trouve
		}
		next unless $OK; # Acclration des recherches...
		if (($OK) && !($Numero)) { # vrai si ok et numero faux
		    $Numero=$.; $ouvert=1; $Ecrit=0; chop($ligne=$_) ;
		} elsif ($OK) { # ligne suivante
		    ($ouvert,$addedligne)=Fortran_Continued($_);
		    if ($ouvert) { # La ligne continue
			$ligne .= $addedligne;
		    } else {
			if ($Ecrit) { # Un match s'est produit...
			    if ($NumListe{$fichier}) {
				$NumListe{$fichier} .= ":$Numero" ;
			    } else {
				$NumListe{$fichier} = "$Numero" ;
				push(@listebis,$fichier);
			    }
			}
			$Numero=0; # remise  zro mais il faut reboucler !!!
			if (($OK)=Fortran_Find_Match($addedligne,$variable)) {
			    $ouvert=1; $Ecrit=0; $Numero=$.; $ligne=$addedligne;
			}
		    }
		}
		if ($ouvert) { # on teste l'affectation de variable
		    $Numero .= ":$." ;
		    if (Find_Egal($ligne,$variable)) { 
			$Ecrit = 1 ; # la variable est affecte.
		    }
		}
            }
            close(FICHIER);
        }
    }
    return(@listebis);
}

#%###################################################
# Recherche des declarations de fonctions ou passages de parametres
sub Proc_Rech_Var_In_WDec {
    local(@listebis)=();
    foreach $variable (@listev) {
	&Fortran_Procedure(@listef,@listehf);
    }
    if (@listebis) {
	if ($debug >= 4) {
	    print STDOUT "\t\tProc_Rech_Var_In_WDec found match.\n";
	}
    } elsif ($debug >= 2) {
        print STDOUT "Proc_Rech_Var_In_WDec found no match for (@listev) in\n";
        &Affiche_Liste(@listef,@listehf);
    }
    return (@listebis);
}
#%###################################################
# Recherche des declarations de fonctions ou passages de parametres
sub Fortran_Procedure {
    local(@listefile)=@_;
    foreach $fichier (@listefile) { # Recherche dans le fortran
	next unless &OPENFICHIER($DIRW,@GETIN_PATH);
	$OK=0; $Numero=0; $ouvert=-1;
	while(<FICHIER>) {
	    next if Fortran_Comment($_); # Commentaire
	    unless ($OK) {
		($OK)=Fortran_Header($_); # vrai si fortran header
	    }
	    if (($OK) && !($Numero)) { # vrai si ok et numero faux
# Dbut de bloc de programme.
		$Numero=$.; $ouvert=0; $Ecrit=0;
	    }
	    if ($ouvert >= 0) {
		$Numero .= ":$." ;
		if ($variable) { 
		    if (Fortran_Find_Match($_,$variable)) { 
			$Ecrit = 1 ;
		    }
		} else {
		    $Ecrit = 1 ;
		}
		if (($ouvert=Parenthesis_Open($_,$ouvert)) == -1) { # () closed
		    if ($Ecrit) { # Un match s'est produit...
			if ($NumListe{$fichier}) {
			    $NumListe{$fichier} .= ":$Numero" ;
			} else {
			    $NumListe{$fichier} = "$Numero" ;
			    push(@listebis,$fichier);
			}
		    }
		    $OK=0; $Numero=0;
		}
	    }
	}
	close(FICHIER);
    }
}

#%###################################################
# Recherche des affectations de variables dans le fortran...
sub Fortran_Egal_Old {
    foreach $variable (@listev) {
        foreach $fichier (@listef,@listehf) { # Recherche dans le fortran
            next unless (&OPENFICHIER($DIRW,@GETIN_PATH));
	    print STDOUT "next done $fichier\n";
            $oldinstruction = "instruction";
# La ligne ci-dessous est inutile
            $instruction = "";
            while(defined($ligne=<FICHIER>)) {
                chop($ligne);
                $commentaire = "";
                if  ($oldinstruction ne $instruction) {
                    $instruction = "" ;
                }
                &Instruction_Commentaire_F ;
                if ( $instruction =~ /\b$variable\b/i) { # Accelere la rech
		    print STDOUT "Chance $instruction $fichier\n";
                    if ( ( $instruction =~ /\b$variable\s*=/i) || ( $instruction =~ /\s+\b(read)\b.*\b$variable\b/i) || ( $instruction =~ /\b$variable\b\s*\([ \w,_\(\)]+\)\s*=/i) ) {
# Egalite uniquement des tableaux ou var. Pour le C on accepte *=
                        if ($NumListe{$fichier}) {
                            $NumListe{$fichier} .= ":$." ;
                        } else {
                            $NumListe{$fichier} = "$." ;
                            push(@listebis,$fichier);
                        }
			$instruction = "" ;
			print STDOUT "Found $. $_ $fichier\n";
                    } else {
# On continue: instruction se rallonge a l'infini, mais ca evite
# de tester la syntaxe. Le test correct est effectue au dessus.
                        $oldinstruction=$instruction;
                    }
                }
            }
            close(FICHIER) ;
        }
    }
}

#%###################################################
# Recherche des affectations de variables
# On peut comparer cette fonction a A_Rech_Var_In_Wdec
# qui toutes deux font abstraction des lignes de commentaire
# du fortran.
# Status: should be bugs free (now)...
sub Rech_Var_In_WEgal {
    local(@listebis)=();
    (@listebis)=(@listebis,&Fortran_Egal);
    foreach $variable (@listev) {
        foreach $fichier (@listec,@listehc) { # Recherche dans le C
            next unless &OPENFICHIER($DIRW,@GETIN_PATH);
            $oldinstruction = "instruction";
            $instruction = "";
            $comm=0;
            while(defined($ligne=<FICHIER>)) {
                chop($ligne);
                $commentaire = "";
                if  ($oldinstruction ne $instruction) {
                    $instruction = "" ;
                }
                &Instruction_Commentaire_CC ;
                if (( $instruction =~ /$variable/i) && ( $instruction =~ /\b$variable\b.*[=+\*\-]/i)) { # Accelere la rech
# On recherche les affectations avec l'operateur egal
                    if ( ( $instruction =~ /\b$variable\s*(.?)=/i) || ( $instruction =~ /\b$variable\s*\[[ \w,_\[\]]+\]\s*(.?)=/i) ) {
# Egalite uniquement des tableaux ou var. Pour le C on accepte *=
                        if ( $1 ne "=" ) { # Pas de condition d'egalite
                            if ($NumListe{$fichier}) {
                                $NumListe{$fichier} .= ":$." ;
                            } else {
                                $NumListe{$fichier} = "$." ;
                                push(@listebis,$fichier);
                            }
                        }
			$instruction = "" ;
# On recherche les affectations avec l'operateur raccourci d'increment $++$
                    } elsif ( ($instruction =~ /\b$variable\s*[+\*\-]{2}\s*;/i) || ($instruction =~ /\b$variable\s*\[[ \w,_\[\]]+\]\s*[+\*\-]{2}\s*;/i) || ( $instruction =~ /\s*[+\*\-]{2}\s*\b$variable\s*;/i) ) {
                        if ($NumListe{$fichier}) {
                            $NumListe{$fichier} .= ":$." ;
                        } else {
                            $NumListe{$fichier} = "$." ;
                            push(@listebis,$fichier);
                        }
			$instruction = "" ;
                    } else {
                        $oldinstruction=$instruction;
                    }
                }
            }
            close(FICHIER) ;
        }
    }
    unless (@listebis) {
        if ($debug >= 2) {print STDOUT "Rech_Var_In_WEgal found no match for (@listev) in\n";}
        if ($debug >= 2) {&Affiche_Liste(@listef,@listehf,@listec,@listehc);}
    }
    return (@listebis);
}

#%###################################################
## Returns the %Ligne table of passages between variables
sub GetLigneOfDiff () {
    ($Routine,$passage)=@_;
    @num = split ( /,/, $passage) ;
    while (@num) {
	$nom_de_passage = shift @num ;
	@var = split ('#',$nom_de_passage) ;
	foreach $variloc (@listev) {
	    if ( $var[0] =~ /^$variloc$/i ) {
		if ($Ligne{$var[0].$Routine}) {
		    $Ligne{$var[0].$Routine} .= ":$compteur $. $fichier $nom_de_passage" ;
		} else {
		    $Ligne{$var[0].$Routine} = "$compteur $. $fichier $nom_de_passage" ;
		}
	    }
	}
	$compteur++ ;
    }
}

#%###################################################
# Recherche de passage de parametre
# On ne fait pas de difference entre le C et le fortran, on recherche
# toujours un call.
sub Rech_Var_In_WParam_P {
    $Routine = "0" ;
    %Called_By_Var = ();
    %Var_Called = ();
    %Ligne = ();
    $call_ok=0;
    foreach $fichier (@listef,@listehf) {
        next unless &OPENFICHIER($DIRW,@GETIN_PATH);
  TOTO:
        while(defined($ligne=<FICHIER>)) {
	    unless ($ligne =~ /^[\s\d]+/){next TOTO;}; ## commentaires eject
##	    if ($ligne =~ /^![\s|\d]/){next TOTO;}; ## commentaires eject
	    if ($ligne =~ /(.*?)\!/){$ligne=$1;}; ## commentaires eject
	    if ( $ligne =~ /.{6}(.*)/ ) { # parenthese: complet
		$ligne = $1;
	    }
            if (( $ligne =~ /call/i ) && (($ligne =~ /\bcall\b\s*(\w+)/i)||($ligne =~ /\bif\b.*\scall\s+(\w+)/i))) {
                $Routine = $1 ;
		$Routine =~ tr/A-Z/a-z/ ;
                $Numero = $. ;
                $passage = "" ;
		if ($ligne =~ /\bif\b.*\bcall\b(.*)/i) {$ligne =$1;};
                ($acco,$instruction)=Instruction_OPN($acco,$ligne,$Routine);
                 if ( $acco == 1) { # detection des commentaires
		    $call_ok=1;
		    $compteur = 0 ;
		}
	    } else { $instruction = $ligne ;};
	    if ($call_ok) {
		($acco,$instruction,$resultat)=Instruction_Parenthese_SN($acco,$instruction,$resultat) ;
## Recherche des variables dans "instruction"
		if ($resultat){
		    $passage .= $resultat ;
## Recherche des variables dans "instruction"
		    $Numero=Instruction_Occurence_perLine($Numero,$fichier,$Routine,$instruction) ; 
		    &GetLigneOfDiff($Routine,$resultat);
		}
	        if ($acco >= 1) {
		    next TOTO;
		} else {
		    $Routine = "0" ;
		    $call_ok = "0" ;
		}
#%#########
#%#########
	    }
           
        }
        close(FICHIER) ;
    }
    unless (%Var_Called) {
        if ($debug >= 2) {
	    print STDOUT "Aucun Paramtre (@listev) pass en argument par un call dans:\n";
	    &Affiche_Liste(@listef,@listehf);
	}
    }
}

#%###################################################
## Returns the %Ligne table of passages between variables
sub GetLigneOfSiff () {
    ($Routine,$passage)=@_;
##    $compteur = 0 ;
    $Routine =~ tr/A-Z/a-z/ ;
    @num = split ( /,/, $passage) ;
    while (@num) {
	$var = shift @num ;
	foreach $variloc (@listev) {
	    if ( $var eq $variloc ) {
		if ($Ligne{$var.$Routine}) {
		    $Ligne{$var.$Routine} .= ":$compteur $. $fichier" ;
		} else {
		    $Ligne{$var.$Routine} = "$compteur $. $fichier" ;
		}
	    }
	}
	$compteur++ ;
    }
}

#%###################################################
# Recherche de passage de parametre
# On ne fait pas de difference entre le C et le fortran, on recherche
# toujours un call.
sub Rech_Var_In_WParam_S {
    $call_ok=0;
    $Routine = "0" ;
    %Called_By_Var = ();
    %Var_Called = ();
    %Ligne = ();
    foreach $fichier (@listef,@listehf) {
        next unless &OPENFICHIER($DIRW,@GETIN_PATH);
  TOTO:
        while(defined($ligne=<FICHIER>)) {
	    unless ($ligne =~ /^[\s\d]+/){next TOTO;}; ## commentaires eject
	    if ($ligne =~ /(.*?)\!/){$ligne=$1;}; ## commentaires eject
	    if ( $ligne =~ /.{6}(.*)/ ) { # parenthese: complet
		$ligne = $1;
	    }
            if (( $ligne =~ /subroutine/i ) && ($ligne =~ /\bsubroutine\b\s*(\w+)/i)) {
                $Routine = $1 ;
		$Routine =~ tr/A-Z/a-z/ ;
                $Numero = $. ;
                $passage = "" ;
                ($acco,$instruction)=Instruction_OPN($acco,$ligne,$Routine);
                 if ( $acco == 1) { # detection des commentaires
		    $call_ok=1;
		    $compteur = 0 ;
		}
	    } else { $instruction = $ligne ;};
	    if ($call_ok) {
		($acco,$instruction,$resultat)=Instruction_Parenthese_SN($acco,$instruction,$resultat) ;
		if ($resultat){
		    $passage .= $resultat ;
## Recherche des variables dans "instruction"
		    $Numero=Instruction_Occurence_perLine($Numero,$fichier,$Routine,$instruction) ; 
		    &GetLigneOfSiff($Routine,$resultat);
		}	
		$Numero=Instruction_Occurence_perLine($Numero,$fichier,$Routine,$instruction) ;
	        if ($acco >= 1) {
		    next TOTO;
		} else {
		    $Routine = "0" ;
		    $call_ok = "0" ;
		}
            }
        }
        close(FICHIER) ;
    }
    unless (%Var_Called) {
        if ($debug >= 2) {
	    print STDOUT "Aucun Paramtre (@listev) dclar en argument de subroutine dans:\n";
	    &Affiche_Liste(@listef,@listehf);
	}
    }
}

#%###################################################
# Recherche de passage de parametre
# On affiche les lignes ou le parametre passe est different de celui declare
sub Affiche_Var_S {
    $call_ok=0;
    print STDOUT "routine(nom_var,fichier_declaration,ligne_declaration,position)[fichier_appel,ligne_appel]=nom_origine\n";
    $Routine = "0" ;
    foreach $fichier (@listef,@listehf) {
        next unless &OPENFICHIER($DIRW,@GETIN_PATH);
  TOTO:
        while(defined($ligne=<FICHIER>)) {
	    unless ($ligne =~ /^[\s\d]+/){next TOTO;}; ## commentaires eject
	    if ($ligne =~ /(.*?)\!/){$ligne=$1;}; ## commentaires eject
	    if ( $ligne =~ /.{6}(.*)/ ) { # parenthese: complet
		$ligne = $1;
	    }
            if (( $ligne =~ /call/i ) && (($ligne =~ /\bcall\b\s*(\w+)/i) ||($ligne =~ /\bif\b.*\scall\s+(\w+)/i))) {
                $instruction = $ligne ;
                $Routine = $1 ;
		$Routine =~ tr/A-Z/a-z/ ;
                $Numero = $. ;
                $passage = "" ;
		if ($ligne =~ /\bif\b.*\bcall\b(.*)/i) {$ligne =$1;};
                ($acco,$instruction)=Instruction_OPN($acco,$ligne,$Routine);
                 if (( $acco == 1)&& ($Var_Called{$Routine})) { # detection des commentaires
		    $call_ok=1;
##		    $compteur = 0 ;
		}
	    } else { $instruction = $ligne ;};
	    if ($call_ok) {
		($acco,$instruction,$resultat)=Instruction_Parenthese_SN($acco,$instruction,$resultat) ;
		$passage .= $resultat ;
	        if ($acco >= 1) {
		    next TOTO;
		} else {
		    $call_ok = "0" ;
		    @num = split ( /,/, $passage) ;
		    foreach $var (@listev) {
			if ($Ligne{$var.$Routine}) {
			    foreach $toto (split (/:/,$Ligne{$var.$Routine})) {
				($num_ligne,$NumC,$file) = split (/ /,$toto) ;
				if ($num[$num_ligne]) {
				    if ($num[$num_ligne] ne $var) {
					$num_ligne_P = $num_ligne + 1 ;
					$nom_de_passage = $num[$num_ligne] ;
					$nom_de_passage =~ s/#/\(/ ;
					$nom_de_passage =~ s/#/\)/ ;
					$nom_de_passage =~ tr /\//,/ ;
					print STDOUT "$Routine($var,$file,$NumC,$num_ligne_P)[$fichier,$Numero]=$nom_de_passage\n";
				    }
				} else {
				    print STDOUT "ZZZERR=#liste[$num_ligne]($fichier-$file-$.-$passage-$instruction)='@num'.\n";
				}
			    }
			}
		    }
		    $Routine = "0" ;
		}
            }
        }
        close(FICHIER) ;
    }
    unless ($num_ligne_P) {
        if ($debug >= 2) {print STDOUT "Dans les passages de Paramtres, tous les arguments passs en argument se correspondent.\n";}
    }
}

#%###################################################
# Recherche de passage de parametre
# On affiche les lignes ou le parametre passe est different de celui declare
sub Affiche_Var_P {
    $call_ok=0;
    $Routine = "0" ;
    print STDOUT "routine(nom_var_appel,fichier_appel,ligne_appel,position)[fichier_declaration,ligne_declaration]=nom_declaration\n";
    foreach $fichier (@listef,@listehf) {
        next unless &OPENFICHIER($DIRW,@GETIN_PATH);
  TOTO:
        while(defined($ligne=<FICHIER>)) {
	    unless ($ligne =~ /^[\s\d]+/){next TOTO;}; ## commentaires eject
	    if ($ligne =~ /(.*?)\!/){$ligne=$1;}; ## commentaires eject
	    if ( $ligne =~ /.{6}(.*)/ ) { # parenthese: complet
		$ligne = $1;
	    }
	    $instruction = $ligne ;
            if (( $ligne =~ /subroutine/i ) && ( $ligne =~ /\bsubroutine\b\s*(\w+)/i)) {
                $Routine = $1 ;
                $Numero = $. ;
                $passage = "" ;
                ($acco,$instruction)=Instruction_OPN($acco,$ligne,$Routine);
                if ($Routine ne "0") {
                    $Routine =~ tr/A-Z/a-z/ ;
		    if (( $acco == 1) && ($Var_Called{$Routine})) {
			$call_ok=1;
		    }                  
		}                 
	    }                 
	    if ($call_ok) {
		($acco,$instruction,$resultat)=Instruction_Parenthese_SN($acco,$instruction,$resultat) ;
		$passage .= $resultat ;
	        if ($acco >= 1) {
		    next TOTO;
		} else {
		    $call_ok = "0" ;
		    @num = split ( /,/, $passage) ;
		    foreach $var (@listev) {
			if ($Ligne{$var.$Routine}) {
			    foreach $toto (split (/:/,$Ligne{$var.$Routine})) {
				($num_ligne,$NumC,$file,$variloc) = split (/ /,$toto) ;
				if ($num[$num_ligne]) {
				    if ($num[$num_ligne] ne $variloc) {
					$num_ligne_P = $num_ligne + 1 ;
					$variloc =~ s/#/\(/ ;
					$variloc =~ s/#/\)/ ;
					$variloc =~ tr /\//,/ ;
					print STDOUT "$Routine($variloc,$file,$NumC,$num_ligne_P)[$fichier,$Numero]=$num[$num_ligne]\n";
				    }
				} else {
				    print STDOUT "@num and $num_ligne\n";
				    die "wrong nb of param in $Routine($fichier) line $. called by file $file at line $NumC";
				}
			    }
			}
		    }
		    $Routine = "0" ;
		    $call_ok = "0" ;
		}
	    }
        }
        close(FICHIER) ;
    }
    unless ($num_ligne_P) {
        if ($debug >= 2) {print STDOUT "Dans les passages de Paramtres, tous les arguments passs en argument se correspondent.\n";}
    }
}

#%#######################################################################
# Recherche de la parenthese ouvrante apres le call. Si on ne trouve pas,
# on quittera la sequence de recherche appelante.
sub Instruction_OPN (){
    local($acco,$instruction,$Routine)=@_;
    $acco=2;
    while ( $acco > 1) {
        if ( $instruction =~ /(.*?)\((.*)/ ) { # parenthese: ouverture
            $instruction = $2 ;
            if (($1) && ($Routine eq "0")) { $Routine = $1 ; } ;
            $acco = 1;
        } elsif (($instruction ne "" ) && ($acco != 2)) {
            $acco = -1 ;
        } elsif (defined($instruction=<FICHIER>)) {
            $acco++ ;
        } else {
            die "Fin du fichier $fichier sans ouverture de parenthese $Numero" ;
        }
    }
    ($acco,$instruction);
} ;

#%###################################################
# Recherche d'occurence dans la variable 'instruction'.
sub Instruction_Occurence_perLine {
    local($Numero,$fichier,$Routine,$instruction)=@_;
    foreach $variable (@listev) {
        if (( $instruction =~ /$variable/i) && ( $instruction =~ /\b$variable\b/i)) {
            if ($Routine ne "0") {
                if ((! $Var_Called{$Routine}) || (($Var_Called{$Routine}) && !($Var_Called{$Routine} =~ /\b$variable\b/i))) {
                    if ($Called_By_Var{$variable}) {
                        $Called_By_Var{$variable} .= " $Routine" ;
                    } else {
                        $Called_By_Var{$variable} = "$Routine" ;
                    }
		}
                if ($Var_Called{$Routine}) {
                    unless ($Var_Called{$Routine} =~ /\b$variable\b/) {
                        $Var_Called{$Routine} .= " $variable" ;
                    }
                } else {
                    $Var_Called{$Routine} = "$variable" ;
                }
            }
#%##
            if ($opt_a) {
                if ($Numero > 0) {
                    if ($NumListe{$fichier}) {
                        $NumListe{$fichier} .= ":$Numero" ;
                    } else {
                        $NumListe{$fichier} = "$Numero" ;
                        push(@listebis,$fichier);
                    }
                    $Numero = -1 ;
                }
                $NumListe{$fichier} .= ":$." ;
            } else {
                if ($Numero > 0) {
                    $Numero = -1 ;
                }
            } # fin du if opt\_a
#%##
        }
    }
    $Numero ; 
}

#%#######################################################################
# Recherche la derniere parenthese dans instruction.
# On garde la variable globale 'acco' en memoire pour savoir quand on a fini
sub Instruction_Parenthese_P {
    $there_remains=1;
    while ($there_remains) {
        if ( $instruction =~ /(.*)\((.*?)\)(.*)/ ) { # parenthese: complet
            $instruction = $1.$3 ;
            $resultat = $1.$3 ;
        } elsif ( $instruction =~ /(.*)\((.*)/ ) { # debut d'accolade
            $instruction = "       ".$2 ;
            $resultat = "       ".$2 ;
            $acco++;
        } elsif ( $instruction =~ /(.*)\)(.*)/ ) { # fin d'accolade
            $instruction = $1.$2 ;
            $resultat = $1 ;
            $acco=$acco-1;
        } else { # a mettre en resultat
            $resultat = $instruction ;
            $there_remains = -1 ;
        }
        if ($there_remains++ >= 20) { die "Trop de parenthses ligne $. de $file" ; } ;
    }
    if ( $resultat =~ /.{6}(.*)/ ) { $resultat = $1 ; $resultat =~ s/ //g ; }
} ;

#%#######################################################################
# Recherche la derniere parenthese dans instruction.
# On garde la variable globale 'acco' en memoire pour savoir quand on a fini
sub Instruction_Parenthese_SN (){
    local($acco,$instruction,$resultat)=@_;
    $there_remains=1;
    while ($there_remains) {
        if ( $instruction =~ /(.*)\((.*?)\)(.*)/ ) { # parenthese: complet
            $loc = $2 ;
            $loc =~ tr/,/\//; 
            $resultat = $1."#$loc#".$3 ;
            $instruction = $resultat ;
        } elsif ( $instruction =~ /\((.*)/ ) { # debut d'accolade
            $instruction = $1 ;
            $resultat = $1 ;
            $acco++;
        } elsif ( $instruction =~ /(.*)\)(.*)/ ) { # fin d'accolade
            $instruction = $1.$2 ;
            $resultat = $1 ;
            $acco=$acco-1;
        } else { # a mettre en resultat
            $resultat = $instruction ;
            $there_remains = -1 ;
        }
        if ($there_remains++ >= 20) { die "Trop de parenthses ligne $. de $file" ; } ;
    }
    $resultat =~ s/ //g ;
    ($acco,$instruction,$resultat);
} ;

#%###################################################
# Affichage des numeros de ligne contenant les variables
sub Affiche_Var_In {
    foreach $fichier (@listebis) {
        $first = 0 ;
        open(FICHIER,$fichier) ;
        (@numero) = &Uniq_Lines($NumListe{$fichier}) ;
        $taille = $#numero ;
        print STDOUT "$fichier:\n";
	$file = $fichier ;
	$file =~ s#^$DIRW\/##;
        while(<FICHIER>) {
            if (($. >= ($numero[$first]-$L_Bef)) && ($. <= ($numero[$first]+$L_Aft))) {
		if ($opt_N) {
                    print STDOUT "$_";
		} else {
                    print STDOUT "$.:$_";
		}
                if  ( $. == ($numero[$first]+$L_Aft)) {
                    if ($first == $taille ) { last ; } ;
                    while (($first < $taille) && ($numero[$first] == $numero[++$first])) {}
                }
            }
        }
        print STDOUT "\t:$fichier.\n";
        close(FICHIER) ;
    }
    if ($debug >= 2) {
	print STDOUT "Au total ".($#listebis+1)." fichiers impliqus:\n" ;
	&Affiche_Liste(@listebis);
    }
    if (($opt_a) && (%Called_By_Var)) {
        print STDOUT "Liste par variable des routines o l'on passe la variable en question en argument:\n" if ($debug >= 1) ; #%'
        foreach $variable (sort keys %Called_By_Var) {
            @listebis = sort split (/ /, $Called_By_Var{$variable}) ;
            print STDOUT "\t$variable: @listebis\n" ;
        }
    }
}

#%###################################################
# Affichage des numeros de ligne contenant les variables
sub Get_Var_Html {
    foreach $fichier (@listebis) {
    $fichier = $opt_fichier ;
	if (exists $Include_Unique{$fichier}) {
# What a Hell !
# How can one be such a silly programmer !
	    $DIRC = $opt_dir ;
	    $outfile = &fichiers::IncludeFileOfWrite($fichier) ;
	} else {
	    $outfile = $fichier ;
	}
	(@numero) = &Uniq_Lines($NumListe{$fichier}) ;
	$NumListe{$fichier} = join ':', @numero ;
    }
}
#%###################################################
# Affichage des numeros de ligne contenant les variables
sub Affiche_Var_Html {
    print STDOUT "<ol>\n";
    foreach $fichier (@listebis) {
	if (exists $Include_Unique{$fichier}) {
# What a Hell !
# How can one be such a silly programmer !
	    $DIRC = $opt_dir ;
	    $outfile = &fichiers::IncludeFileOfWrite($fichier) ;
	} else {
	    $outfile = $fichier ;
	}
	(@numero) = &Uniq_Lines($NumListe{$fichier}) ;
	$NumListe{$fichier} = join ':', @numero ;
	print STDOUT "<li><A Href=\"view.pl?lines=$NumListe{$fichier}\&dir=$opt_dir\&file=$outfile\&html=$opt_html\" TARGET=\"source\">$fichier</A>\n";
	(@numero) = sort numerique split(/:/, $NumListe{$fichier});
	print STDOUT "<ul>\n";
	foreach $n (@numero) {
	    print STDOUT "<li><A Href=\"view.pl#$n?lines=$NumListe{$fichier}\&dir=$opt_dir\&file=$outfile\&html=$opt_html\" TARGET=\"source\">$n</A>\n";
	}
	print STDOUT "</ul>\n";
    }
    print STDOUT "</ol>\n";
    if (($opt_a) && (%Called_By_Var)) {
        print STDOUT "Liste par variable des routines o l'on passe la variable en question en argument:\n" ; #%'
        foreach $variable (sort keys %Called_By_Var) {
            @listebis = sort split (/ /, $Called_By_Var{$variable}) ;
            print STDOUT "\t$variable: @listebis\n" ;
        }
    }
}

#%###################################################
# Affichage des numeros de ligne contenant les variables
sub Affiche_Var_Out {
    foreach $fichier (@listebis) {
        $first = 0 ;
        open(FICHIER,$fichier) ;
        (@numero) = &Uniq_Lines($NumListe{$fichier}) ;
        $taille = $#numero ;
        print STDOUT "$fichier:\n";
	$file = $fichier ;
	$file =~ s#^$DIRW\/##;
        while(<FICHIER>) {
            if (($. >= ($numero[$first]-$L_Bef)) && ($. <= ($numero[$first]+$L_Aft))) {
                if  ( $. == ($numero[$first]+$L_Aft)) {
                    while (($first < $taille) && ($numero[$first] == $numero[++$first])) {}
                }
            } else {
		if ($opt_N) {
		    print STDOUT "$_";
		} else {
		    print STDOUT "$.:$_";
		}
	    }
        }
        print STDOUT "\t:$fichier.\n";
        close(FICHIER) ;
    }
    if ($debug >= 2) {
	print STDOUT "Au total ".($#listebis+1)." fichiers impliqus:\n";
	&Affiche_Liste(@listebis);
    }
    if (($opt_a) && (%Called_By_Var)) {
        print STDOUT "Liste par variable des routines o l'on passe la variable en question en argument:\n" ; #%'
        foreach $variable (sort keys %Called_By_Var) {
            @listebis = sort split (/ /, $Called_By_Var{$variable}) ;
            print STDOUT "\t$variable: @listebis\n" ;
        }
    }
}

#%###################################################
sub Uniq_Lines {
    my(@numero) = sort numerique split(/:/, $NumListe{$fichier});
    my(%ok) = ();
    foreach $n (@numero) {
	$ok{$n} = 1 ;
    }
    (@numero) = (keys %ok) ;
    return (@numero) ;
}
#%###################################################
# Affichage des numeros de ligne contenant les variables
sub Affiche_Var_E {
    foreach $fichier (@listebis) {
        $first = 0 ;
        open(FICHIER,$fichier) ;
        (@numero) = &Uniq_Lines($NumListe{$fichier}) ;
        $taille = $#numero ;
	$file = $fichier ;
	$file =~ s#^$DIRW\/##;
        print STDOUT "$fichier:\n";
RFILE1:
        while(<FICHIER>) {
            if (($. >= ($numero[$first]-$L_Bef)) && ($. <= ($numero[$first]+$L_Aft))) {
		if  ( $. == ($numero[$first]+$L_Aft)) {
#                    print STDOUT "line $. of $fichier:$_";
                    print STDOUT "$file $.:$_";
                    if ($first == $taille ) {
                        last RFILE1;   
                    }
                    while (($first < $taille) && ($numero[$first] == $numero[++$first])) {}
                } else {
#                    print STDOUT "line $. of $fichier:$_";
                    print STDOUT "$file $.:$_";
                }
            }
        }
        print STDOUT "\t:$fichier.\n";
        close(FICHIER) ;
    }
    if ($debug >= 2) {
	print STDOUT "Au total ".($#listebis+1)." fichiers impliqus";
	if (($opt_E) || ($opt_C)) {
	    print STDOUT ".\n" ;
	} else {
	    print STDOUT ":\n@listebis.\n" ;
	}
    }
    if (($opt_a) && (%Called_By_Var)) {
        print STDOUT "Liste par variable des routines o l'on passe la variable en question en argument:\n" ;
        foreach $variable (sort keys %Called_By_Var) {
            @listebis = sort split (/ /, $Called_By_Var{$variable}) ;
            print STDOUT "\t$variable: @listebis\n" ;
        }
    }
}

#%###################################################
# Affichage des numeros de ligne contenant les variables
sub Affiche_Var_C {
    foreach $fichier (@listebis) {
        $first = 0 ;
        open(FICHIER,$fichier) ;
        (@numero) = &Uniq_Lines($NumListe{$fichier}) ;
        $taille = $#numero ;
        print STDOUT "$fichier:\n";
	$file = $fichier ;
	$file =~ s#^$DIRW\/##;
RFILE1:
        while(<FICHIER>) {
            if (($. >= ($numero[$first]-$L_Bef)) && ($. <= ($numero[$first]+$L_Aft))) {
                if  ( $. == $numero[$first]) {
                    print STDOUT "line $. of $file:$_";
                } elsif  ( $. == ($numero[$first]+$L_Aft)) {
                    print STDOUT "line $. of $file:$_";
                    if ($first == $taille ) {
                        last RFILE1;   
                    }
                    while (($first < $taille) && ($numero[$first] == $numero[++$first])) {}
                } else {
                    print STDOUT "line $. of $file:$_";
                }
            }
        }
        print STDOUT "\t:$fichier.\n";
        close(FICHIER) ;
    }
    if ($debug >= 2) {print STDOUT "Au total ".($#listebis+1)." fichiers impliqus: @listebis.\n" ;}
    if (($opt_a) && (%Called_By_Var)) {
        print STDOUT "Liste par variable des routines o l'on passe la variable en question en argument:\n" ;
        foreach $variable (sort keys %Called_By_Var) {
            @listebis = sort split (/ /, $Called_By_Var{$variable}) ;
            print STDOUT "\t$variable: @listebis\n" ;
        }
    }
}

#%###################################################
sub numerique { $a <=> $b; }

#%###################################################
print STDOUT $q->end_html;    
