package viewhtml;
use File::Basename ;
#%###################################################
sub numerique { $a <=> $b; }
#%###################################################
sub get_html_file {
    my($rep,$fic) = @_ ;
    $fic = basename($fic) ;
    return("$rep/${fic}_c.html") ;
}
#%###################################################
sub View_Core {
    my($sourcedir,$sourcefile,$lines) = @_ ;
    $htmlfile = &get_html_file($sourcedir,$sourcefile) ;
    if (open(HTML,"<$htmlfile")) {
	(@numero) = sort numerique split(/:/, $lines);
	print STDOUT "<ul>\n";
	foreach $n (@numero) {
	    print STDOUT "<li><A Href=\"#$n\">$n</A>\n";
	}
	print STDOUT "</ul>\n";
	$first = 0 ;
	$taille = $#numero ;
	while (<HTML>) {
	    chop ;
	    if ((/IMG/) && (/<IMG\sSRC="(.*?)"/)) {
		$img = $1 ;
		if ($1 =~ /^\w+/) {
		    $_ =~ s#$img#file:$sourcedir/$img# ;
		}
	    } elsif ((/LINK/) && (/<LINK\sREL=STYLESHEET\s.*?\sHREF="(.*)">/)) {
		if ($1 eq "ftagshtml.css") {
		    $_ =~ s#$1#file:$sourcedir/ftagshtml.css# ;
		}
	    }
	    if ((/<A/) && (/<A\s+Href="(.*?)"/i)) {
		$img = $1 ;
		if ($1 =~ /^\w+/) {
		    $_ =~ s#$img#file:$sourcedir/$img# ;
		}
	    }
	    if (/<!LINE=(\d+)>/) {
		$n = $1 ;
		if ($n == ($numero[$first])) {
#		print STDOUT "<A Name=$n><A><I><U><FONT CLASS=\"getin\" SIZE=+1>$_</FONT><FONT COLOR=GREEN>&lt;line number $n&gt;</FONT></U></I>\n" ;
		    print STDOUT "<A Name=$n><A><I><U>$_<FONT COLOR=GREEN>&lt;line number $n&gt;</FONT></U></I>\n" ;
		    $first++ unless ($first >= $taille) ;
		} else {
		    print STDOUT $_."\n" ;
		}
	    } else {
# Error...
		print STDOUT $_."\n" ;
	    }
	}
	close(HTML) ;
    } else {
	print STDOUT "<BR> Unable to open $htmlfile\n";
    }
}
#%###################################################
1;
